//=============================================================================
// ֐ۑ邽߂̃NXB
//=============================================================================
#include	<windows.h>
#include	<commctrl.h>
#include	<iostream>
#include	<fstream>
#include	<vector>
using namespace std;
#include	<comdef.h>
#include	"common.h"
#include	"SvFileStack.h"
#include	"SvClass.h"
#include	"SvFunction.h"
#include	"SvFileNo.h"
#include	"SvVariable.h"


extern	SvFileNo	*FileNoObj;					// t@C̕ۑpIuWFNg
extern	SvFileStack	*FileStackObj;					// ݏ̃t@Ci[IuWFNg
extern	SvClass		*ClassObj;					// NXi[ĂIuWFNg
extern	SvVariable	*VariableObj;					// ϐi[ĂIuWFNg
extern	Option		EpOp;

std::vector<int> vecFuncGyouData;					// ֐̍sz̕ۊǏꏊ


//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
SvFunction::SvFunction()
{
	memset(skip ,'\0',sizeof(skip ));
	//-------------------------------------------------------
	if( EpOp.PC9801 ){						// PC-98x1
		pBar    = "E" ;
		pChoice = "E" ;
		pEnd    = "E" ;
	}else{
		pBar    = "" ;
		pChoice = "" ;
		pEnd    = "" ;
	}

	if(EpOp.FileFormat == FILE_FORMAT_HTML){
		pSpace = "@";
	}else{
		pSpace = "  ";
	}
}

//--------------------------------------------------------------------------
// fXgN^
// svɂȂGAJ
//--------------------------------------------------------------------------
SvFunction::~SvFunction()
{
}

//--------------------------------------------------------------------------
// ֐ꎞIɕύX
// 
//--------------------------------------------------------------------------
std::string SvFunction::ChangeTrueName(FuncParam &FuncData)
{
	std::string LongName;
	char *pp = NULL;
	int  id = 0;


	// ֐𒷂Oɕϊ
	if( FuncData.strUsingName.length() ){
		LongName  = FuncData.strUsingName;
		LongName += "::";
	}
	if( FuncData.strClassName.length() ){
		LongName += FuncData.strClassName;
		LongName += "::";
	}
	LongName += FuncData.strFuncName;

	switch(FileStackObj->SrcLang()){
	case MASK_BIT_DELPHI:
		return LongName;
	case MASK_BIT_VB:
		// t@C`FbN
		pp = strrchr(FileStackObj->GetFileName(), '.');
		if( pp && !stricmp(pp, ".bas") ){
			return LongName;
		}
		break;
	default:
		// main֐Ŗꍇ
		if( strcmp(FuncData.strFuncName.c_str(), "main") ){
			return LongName;
		}
		break;
	}

	// main֐̌@t@C
	// VB̏ꍇAftHg@t@Ct
	LongName += "@";
	LongName += FileStackObj->GetCFileName(1);

	return LongName;
}


//--------------------------------------------------------------------------
// ֐ZbgB(֐`A܂͐錾Ăꍇ̂)
// ֐Ŗm̊֐𔭌 "SetChildFunc( )" gB
// ֐̓o^ꏊ̍ŏ̓_~[ƂĎgȂ
//
// FuncParam FuncData :֐
// int       FuncBit  : SET_FUNC_XXX Q common.h
//--------------------------------------------------------------------------
void SvFunction::Func_Set(FuncParam &FuncData, int FuncBit, char *Comment)
{
	std::string SetFuncName = ChangeTrueName(FuncData);	// O::NX::֐Ƃ`ɕϊ

	int a = Func_SetSub(SetFuncName, FuncBit);		// ֐Zbg
	if( a == -1 ){
		return;
	}

	int GetPos = vecSortData[a];

	// ֐̃\[Xt@Cѓo^sZbg
	if(FuncBit & SET_FUNC_DECLARE){
		// VB API֐`ꍇ
	}else if((vecFuncData[GetPos].BitInfo & FUNC_BIT_LINE_NO) == 0 && FuncData.LineNo){
		vecFuncData[GetPos].LineNo = FuncData.LineNo;
		// ֐wb_[Œ`ꍇ̂ŁAGetFileName()gp
		vecFuncData[GetPos].SrcFNameID = FileNoObj->SetData( FileStackObj->GetFileName() );
	}
	// ֐wb_̃Rgۑ
	if(vecFuncData[GetPos].strComment.length() == 0 && Comment){
		vecFuncData[GetPos].strComment = Comment;
	}else if( !(vecFuncData[GetPos].BitInfo & FUNC_BIT_LINE_NO) && Comment){
		vecFuncData[GetPos].strComment = Comment;
	}
	// ֐̌^ۑ
	if(vecFuncData[GetPos].strType.length() == 0 && FuncData.strType.length()){
		vecFuncData[GetPos].strType = FuncData.strType;
	}
	// ֐̈ۑ
	if(vecFuncData[GetPos].strArg.length() == 0 && FuncData.strArg.length()){
		vecFuncData[GetPos].strArg = FuncData.strArg;
	}else if((vecFuncData[GetPos].BitInfo & FUNC_BIT_LINE_NO) == 0){
		vecFuncData[GetPos].strArg = FuncData.strArg;
	}
}

//--------------------------------------------------------------------------
// ֐Zbg
// ֐Ŗm̊֐𔭌 "SetChildFunc( )" gB
// ֐̓o^ꏊ̍ŏ̓_~[ƂĎgȂ
// 
// int       FuncBit : SET_FUNC_XXX Q common.h
//--------------------------------------------------------------------------
int SvFunction::Func_SetSub(std::string &strMyFunc, int FuncBit)
{
	FuncInfo tmpFunc;
	int SetPos;


	if( strMyFunc.length() == 0 || *strMyFunc.c_str() == ' ' ){
		cerr << "    " << CoutMask(FileStackObj->GetFileName()) << " " << FileStackObj->GetLineNo();
		cerr << ": NULL֐o^悤ƂĂ܂B[Func_SetSub](װ)" << endl;
		return -1;
	}

	if( Search((char *)strMyFunc.c_str(), &SetPos) ){		// ɓo^Ă
		if(FuncBit & SET_FUNC_REGIST){				// ֐Ƃēo^Ȃ
			vecFuncData[vecSortData[SetPos]].BitInfo |= FUNC_BIT_REGIST;
		}
		if(FuncBit & SET_FUNC_FPOINTA){				// ֐|C^̏ꍇ
			vecFuncData[vecSortData[SetPos]].BitInfo |= FUNC_BIT_POINTA;
		}
		if(FuncBit & SET_FUNC_INTERRUPT){			// 荞݊֐̏ꍇ
			vecFuncData[vecSortData[SetPos]].BitInfo |= FUNC_BIT_INTERRUPT;
		}
		if(FuncBit & SET_FUNC_OPERATOR){			// Zq̃I[o[[h̏ꍇ
			vecFuncData[vecSortData[SetPos]].BitInfo |= FUNC_BIT_OPERATOR;
		}
		return SetPos;
	}

	// ǉf[^
	tmpFunc.strFuncName = strMyFunc;
	tmpFunc.BitInfo   = 0;
	tmpFunc.SrcFNameID= 0;
	tmpFunc.LineNo    = 0;
	tmpFunc.func_step = 0;
	tmpFunc.statck    = 0;
	tmpFunc.ChildYukoCnt = 0;
	if(FuncBit & SET_FUNC_REGIST){					// ֐Ƃēo^Ȃ
		tmpFunc.BitInfo |= FUNC_BIT_REGIST;
	}
	if(FuncBit & SET_FUNC_CHILD){						// q֐VKo^ꍇ
		tmpFunc.BitInfo |= FUNC_BIT_CHILDFUNC;
	}
	if(FuncBit & SET_FUNC_FPOINTA){					// ֐|C^̏ꍇ
		tmpFunc.BitInfo |= FUNC_BIT_POINTA;
	}
	if(FuncBit & SET_FUNC_INTERRUPT){					// 荞݊֐̏ꍇ
		tmpFunc.BitInfo |= FUNC_BIT_INTERRUPT;
	}
	if(FuncBit & SET_FUNC_OPERATOR){					// Zq̃I[o[[h̏ꍇ
		tmpFunc.BitInfo |= FUNC_BIT_OPERATOR;
	}

	// f[^̕я̓\[gp̃Reiɕۑ
	if((int)vecSortData.size() > SetPos){
		vecSortData.insert(vecSortData.begin()+SetPos, (int)vecFuncData.size());
	}else{
		vecSortData.push_back((int)vecFuncData.size());
	}

	// f[^͍Ōɒǉ
	vecFuncData.push_back(tmpFunc);

	return SetPos;
}

//--------------------------------------------------------------------------
// ֐`Ă邩ǂ
// ߂lF 0         (SetPos = }ʒuAG[̏ꍇ-1)
//       F 1 o^ς    (SetPos = o^ʒu)
//--------------------------------------------------------------------------
int SvFunction::Search(char *MyFunc)
{
	int dummy;

	return Search(MyFunc, &dummy);
}

//--------------------------------------------------------------------------
// ֐`Ă邩ǂ
// ߂lF 0         (SetPos = }ʒuAG[̏ꍇ-1)
//       F 1 o^ς    (SetPos = o^ʒu)
//--------------------------------------------------------------------------
int SvFunction::Search(char *MyFunc, int *SetPos)
{
	int max = (int)vecFuncData.size()-1;					// zɕϊ
	int min = 0;
	int half= 0;
	int result;

	if(MyFunc == NULL || *MyFunc == '\0'){
		cerr << "NULL֐悤ƂĂ܂B[Func_Search](װ)" << endl;
		*SetPos = -1;
		return 0;
	}

	if( vecFuncData.size() ){
		while(1){
			half = (min+max)/2;					// ̒n_
			int GetPos = vecSortData[half];
			result = MyFunc_strcmp(MyFunc, (char *)vecFuncData[GetPos].strFuncName.c_str());

			if(result == 0){					// ֐v
				*SetPos = half;
				return 1;
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{							// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}
	*SetPos = half;

	return 0;
}


//--------------------------------------------------------------------------
// ֐ŎgpĂ֐o^B(I[o[[h)
// Parent  : e֐
// Child   : q֐
// ֐̓o^ꏊ̍ŏ̓_~[ƂĎgȂ
// 
// int       FuncInfo : SET_FUNC_XXX Q common.h
//--------------------------------------------------------------------------
void SvFunction::SetChildFunc(FuncParam &Parent, FuncParam &Child, int FuncInfo)
{
	struct MemIdAndPointa{
		int	SetPos;
		std::string	str;
	};
	int ParentID = -1;
	int ChildID  = -1;
	MemIdAndPointa	ParentFunc;
	MemIdAndPointa	ChildFunc;


	ParentFunc.SetPos = 0;
	ChildFunc.SetPos = 0;

	if(Parent.strFuncName.length() == 0 || Child.strFuncName.length() == 0){			// vIG[
		cerr << "װ܂B֐ [SetChildFunc]" << endl;
		cerr << "    e֐  [" << Parent.strFuncName.c_str()   << "]" << endl;
		cerr << "    q֐  [" << Child.strFuncName.c_str() << "]" << endl;
		return;
	}

	if( Parent.strClassName.length() ){				// NX݂
		char *tmp_a = ClassObj->GetBaseClass(Parent.strClassName, Parent.strFuncName);	// e֐̊{NX
		if(*tmp_a != '\0')					// {NX݂
			Parent.strClassName = tmp_a;			// AhXڑ
	}
	if(Child.strClassName.length() == 0){				// {IɃ\bhɂ̓NX͕tȂ̂
		Child.strClassName = ClassObj->GetBaseClass(Parent.strClassName, Child.strFuncName);	// ̃NXɑĂ邩`FbN
	}else if(Child.strClassName.compare("O[o֐") == 0){
		Child.strClassName = "";
	}else{
		char *tmp_b = ClassObj->GetBaseClass(Child.strClassName, Child.strFuncName);	// q֐̊{NX
		if(*tmp_b != '\0')					// {NX݂
			Child.strClassName = tmp_b;			// AhXڑ
	}

	ParentFunc.str = ChangeTrueName(Parent);				// O::NX::֐@t@CƂ`ɕϊ
	ChildFunc.str  = ChangeTrueName(Child);				// O::NX::֐@t@CƂ`ɕϊ

	if(MyFunc_strcmp((char *)ParentFunc.str.c_str(), (char *)ChildFunc.str.c_str()) == 0){	// ĉA
		ParentFunc.SetPos = Func_SetSub(ParentFunc.str, SET_FUNC_REGIST);
		if(ParentFunc.SetPos == -1){
			return;
		}
		ParentID = vecSortData[ParentFunc.SetPos];		// ̕ۑԍɕϊ
		vecFuncData[ParentID].BitInfo |= FUNC_BIT_LOOP;	// ĉAtO𗧂Ă
		return;
	}

	// q֐̔ԍ܂擾B e֐͓o^ς݂Ȃ̂ŖȂA
	// q̊֐̓o^̎_ōsƐěԍ邽߁B
	ChildFunc.SetPos  = Func_SetSub(ChildFunc.str, FuncInfo|SET_FUNC_CHILD);	// pԍ擾
	ParentFunc.SetPos = Func_SetSub(ParentFunc.str, SET_FUNC_REGIST);	// pԍ擾

	if( ChildFunc.SetPos == -1 || ParentFunc.SetPos == -1 ){
		return;
	}
	ChildID  = vecSortData[ChildFunc.SetPos];			// ̕ۑԍɕϊ
	ParentID = vecSortData[ParentFunc.SetPos];			// ̕ۑԍɕϊ

	FuncConnection(ParentID, ChildID, 1);
}


//--------------------------------------------------------------------------
// q֐̃\[go^
// ߂l  -1    Fo^Ă or G[̏ꍇ
//         ̑Fq֐o^ʒu
//--------------------------------------------------------------------------
int SvFunction::InsertChild(std::string &strCmpName, std::vector<int> &vecChildID)
{
	int max = (int)vecChildID.size()-1;				// zɕϊ
	int min = 0;
	int half= 0;
	int result;

	if( vecChildID.size() ){
		while(1){
			half = (min+max)/2;				// ̒n_
			int GetNo = vecChildID[half];
			result = MyFunc_strcmp((char *)strCmpName.c_str(),
					(char *)vecFuncData[GetNo].strFuncName.c_str());
			if(result == 0){
				return -1;
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{						// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}
	return half;
}

//--------------------------------------------------------------------------
// ֐̐eq֌W쐬ۑ
// ParentID Fe֐̔ԍ
// ChildID  Fq֐̔ԍ
// ChildFlg FSetChildFunc֐Ăяoꂽǂ
// ߂l  0Fo^̏ꍇ
//        -1Fɓo^Ăꍇ
//--------------------------------------------------------------------------
int SvFunction::FuncConnection(int ParentID, int ChildID, int ChildFlg)
{
	int Max = (int)vecFuncData[ParentID].vecChildID.size();
	int cc=0;
	int sort_op = EpOp.not_sort ? 0 : 1;				// sort


	if( sort_op ){							// \[gꍇ
		cc = InsertChild(vecFuncData[ChildID].strFuncName,
				vecFuncData[ParentID].vecChildID);
		if(cc == -1){
			return -1;
		}
	}else if(EpOp.SameFuncDisp == 1 && ChildFlg == 1){		// ֐̏dꍇ
		cc = Max;
	}else{
		for(cc=0;cc<Max;cc++){					// ֐̊֘Ats
			if(vecFuncData[ParentID].vecChildID[cc] == ChildID){	// ɓo^Ă
				return -1;
			}
		}
	}
	if((int)vecFuncData[ParentID].vecChildID.size() > cc){
		vecFuncData[ParentID].vecChildID.insert(vecFuncData[ParentID].vecChildID.begin()+cc, ChildID);
	}else{
		vecFuncData[ParentID].vecChildID.push_back(ChildID);
	}


	// e֐o^
	Max = vecFuncData[ChildID].vecParentID.size();
	if( sort_op ){							// \[gꍇ
		cc = InsertChild(vecFuncData[ParentID].strFuncName,
				vecFuncData[ChildID].vecParentID);
		if(cc == -1){
			return -1;
		}
	}else if(EpOp.SameFuncDisp == 1 && ChildFlg == 1){		// ֐̏dꍇ
		cc = Max;
	}else{
		for(cc=0;cc<Max;cc++){					// ֐̊֘Ats
			if(vecFuncData[ChildID].vecParentID[cc] == ParentID){	// ɓo^Ă
				return 0;
			}
		}
	}
	if((int)vecFuncData[ChildID].vecParentID.size() > cc){
		vecFuncData[ChildID].vecParentID.insert(vecFuncData[ChildID].vecParentID.begin()+cc, ParentID);
	}else{
		vecFuncData[ChildID].vecParentID.push_back(ParentID);
	}

	return 0;
}


//--------------------------------------------------------------------------
// RXgN^fXgN^TREEɑgݍވׂ̏
// ĉAœ삵Ă
// char *searchCL : ẽNX
// int  BangoCL   : e֐̔ԍ
// int  dest_flg  : fXgN^̏ꍇ1
//--------------------------------------------------------------------------
void SvFunction::SetConstTree(char *searchCL, int BangoCL, int dest_flg)
{

	for(int a=0;;a++){						// RXgN^fXgN^̊֘At
		char *GetClass = ClassObj->GetKeishyou(searchCL, a);	// pĂNX擾
		if(*GetClass == '\0')
			break;
		std::string LongFuncName;

		LongFuncName  = GetClass;
		LongFuncName += "::";
		if( dest_flg ){
			LongFuncName += "~";
		}
		// ֐擾
		char *pFunc = strrchr(GetClass, ':');
		if( pFunc ){
			pFunc++;
		}else{
			pFunc = GetClass;
		}
		LongFuncName += pFunc;

		// G[܂̓RXgN^orfXgN^o^ĂȂ
		int SetPos;
		if(Search((char *)LongFuncName.c_str(), &SetPos) == 0){
			continue;
		}

		int GetBango = vecSortData[SetPos];
		if(FuncConnection(BangoCL, GetBango, 0) == -1){
			return;
		}
		SetConstTree(GetClass, GetBango, dest_flg);		// ĉA
	}
}

//--------------------------------------------------------------------------
// IuWFNg̐ŎɎgpRXgN^fXgN^
// TREEo͂ł悤ɑgݍ
// OwnerClassFL҂̃NX
// Ownerfunc FL҂̊֐
// MyClass   FNX
// dest_flg  FfXgN^̏ꍇ1
//--------------------------------------------------------------------------
void SvFunction::SetConstOrDest(std::string &strOwnerClass, std::string &strOwnerfunc, char *MyClass, int dest_flg)
{
	int BangoCL=0;							// RXgN^̓fXgN^̔ԍ
	int SortCL;
	std::string LongFuncName;


	//---------------------------------------------------------------
	// ֐̓o^
	//---------------------------------------------------------------
	// RXgN^orfXgN^쐬
	LongFuncName  = MyClass;
	LongFuncName += "::";
	if( dest_flg ){
		LongFuncName += "~";
	}
	// std::string::~string Ƃ悤Ȋ֐쐬邽
	char *pFunc = strrchr(MyClass, ':');
	if( pFunc ){
		pFunc++;
	}else{
		pFunc = MyClass;
	}
	LongFuncName += pFunc;

	SortCL = Func_SetSub(LongFuncName, SET_FUNC_REGIST);		// ֐̕ۑԍ擾
	if( SortCL == -1 ){
		return;
	}
	BangoCL = vecSortData[SortCL];

	SetConstTree(MyClass, BangoCL, dest_flg);			// RXgN^̊֘At

	//---------------------------------------------------------------
	// e֐̌ԍ
	//---------------------------------------------------------------
	LongFuncName = "";

	if(strOwnerfunc.length() == 0){
		if(strOwnerClass.length() == 0){
			return;
		}
		// NXL̏ꍇ
		LongFuncName  = strOwnerClass;
		LongFuncName += "::";
		if( dest_flg ){						// IuWFNg̃fXgN^̓NX̃fXgN^ɐڑ
			LongFuncName += "~";
		}
		LongFuncName += strOwnerClass;
	}else{
		if( strOwnerClass.length() ){
			LongFuncName  = strOwnerClass;
			LongFuncName += "::";
		}
		LongFuncName += strOwnerfunc;
		if(MyFunc_strcmp((char *)strOwnerfunc.c_str(), "main") == 0){
			// main֐̌@t@C
			LongFuncName += "@";
			LongFuncName += FileStackObj->GetCFileName(1);
		}
	}

	int SortFn = Func_SetSub(LongFuncName, SET_FUNC_REGIST);	// ֐̕ۑԍ擾
	if(SortFn != -1){						// e֐Ȃ
		FuncConnection(vecSortData[SortFn], BangoCL, 0);	// ֐̊֘At
	}
}

//--------------------------------------------------------------------------
// ֐QƂO[oϐۑ
//--------------------------------------------------------------------------
void SvFunction::SetObjAccess(FuncParam &FuncData, std::string &strObjName)
{
	int  SetPos;

	if(FuncData.strFuncName.length() == 0){				// ֐
		return;
	}

	std::string SetFuncName = ChangeTrueName(FuncData);

	if(Search((char *)SetFuncName.c_str(), &SetPos) == 0){		// o^ĂȂ
		return;
	}
	int GetNo = vecSortData[SetPos];

	int max = vecFuncData[GetNo].vecRabelstr.size();
	for(int cnt=0;cnt<max;cnt++){
		int ret = MyFunc_strcmp((char *)strObjName.c_str(),
				(char *)vecFuncData[GetNo].vecRabelstr[cnt].c_str());
		if(ret == 0){
			// ɓo^Ă
			return;
		}else if(ret < 0){
			vecFuncData[GetNo].vecRabelstr.insert(vecFuncData[GetNo].vecRabelstr.begin()+cnt, strObjName);
			return;
		}
	}
	vecFuncData[GetNo].vecRabelstr.push_back(strObjName);
}

//--------------------------------------------------------------------------
// ֐̍sуX^bNTCYL^
//--------------------------------------------------------------------------
void SvFunction::SetLineCnt(FuncParam &FuncData, int f_step, int BracketCnt)
{
	int  StkErr;
	int  Stack = VariableObj->GetStackSize(BracketCnt, &StkErr);	// X^bNTCY擾


	if(FuncData.strFuncName.length() == 0){				// ֐
		return;
	}

	std::string SetFuncName = ChangeTrueName(FuncData);

	int  SortPos;
	if(Search((char *)SetFuncName.c_str(), &SortPos) == 0){		// o^ĂȂ
		return;
	}
	int GetNo = vecSortData[SortPos];

	vecFuncData[GetNo].func_step = f_step;
	vecFuncData[GetNo].BitInfo |= FUNC_BIT_LINE_NO;			// ֐ꂽsm
	vecFuncData[GetNo].statck = Stack;
	if( StkErr ){							// gpX^bNTCYsmȂ
		vecFuncData[GetNo].BitInfo |= FUNC_BIT_STK_ERR;
	}

	if(FuncData.strSrcFName.length() && vecFuncData[GetNo].SrcFNameID == 0){
		vecFuncData[GetNo].SrcFNameID = FileNoObj->SetData((char *)FuncData.strSrcFName.c_str());
	}
}

//--------------------------------------------------------------------------
// ֐̌^Ԃ
//--------------------------------------------------------------------------
char *SvFunction::GetFuncType(int No)
{
	if(No >= (int)vecFuncData.size()){
		return "";
	}

	int GetNo = vecSortData[No];

	return (char *)vecFuncData[GetNo].strType.c_str();
}

//--------------------------------------------------------------------------
// t@CɊ܂܂֐̐Zbg
//--------------------------------------------------------------------------
int  SvFunction::MakeSrcFCnt(std::string &strSrcFName)
{
	int cnt = 0;

	if(strSrcFName.length() == 0){
		return 0;
	}

	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		// sԍ肵ĂȂ
		if((vecFuncData[aa].BitInfo & FUNC_BIT_LINE_NO) == 0){
			continue;
		}
		char *SrcFNameX = FileNoObj->GetFileName(vecFuncData[aa].SrcFNameID);
		if( SrcFNameX ){					// ̂`Ă΃\[X
			if( ! MyFunc_strcmp((char *)strSrcFName.c_str(), SrcFNameX) ){
				cnt++;
			}
		}
	}
	return cnt;
}

//--------------------------------------------------------------------------
// VBADelphip̊֐
// \[Xt@CIASetChildFunc֐œo^
// ֐݂邩`FbNB݂ȂꍇAqȂB
//--------------------------------------------------------------------------
void SvFunction::FileEnd()
{
	int  tmp  = FUNC_BIT_CHILDFUNC;
	int  mask = ~tmp;
	int  kari_mask;

	tmp = FUNC_BIT_REGIST;
	kari_mask = ~tmp;

	int OrgMax = (int)vecFuncData.size();
	for(int aa=0;aa<OrgMax;aa++){
		int FuncInfo = 0;
		if(vecFuncData[aa].strFuncName.length() == 0){
			break;
		}
		if(vecFuncData[aa].BitInfo & FUNC_BIT_LINE_NO){			// sԍɌς݂Ȃ
			continue;
		}
		if((vecFuncData[aa].BitInfo & FUNC_BIT_CHILDFUNC) == 0){	// SetChildFunc֐œo^̂łȂ
			continue;
		}
		if(vecFuncData[aa].BitInfo & FUNC_BIT_REGIST){
			FuncInfo = SET_FUNC_REGIST;
		}
		// ֐݂̎̂Ȃ̂ŉo^ɕύX
		vecFuncData[aa].BitInfo &= kari_mask;
		vecFuncData[aa].BitInfo &= mask;

		// ֐݂̂œo^Ȃ
		std::string strNewFuncName = vecFuncData[aa].strFuncName;

		char *p = strchr((char *)strNewFuncName.c_str(), '@');
		if(p){
			*p = '\0';
		}
		int SetPos = Func_SetSub(strNewFuncName, FuncInfo);
		int GetNewNo = vecSortData[SetPos];

		for(int f=0;f<(int)vecFuncData.size();f++){
			int childmax = (int)vecFuncData[f].vecChildID.size();
			for(int cnt=0;cnt<childmax;cnt++){
				// ȑO̔ԍƈv֘At
				if(vecFuncData[f].vecChildID[cnt] == aa){
					FuncConnection(f, GetNewNo, 1);
					break;
				}
			}
		}
	}
}


//--------------------------------------------------------------------------
// ֐̍sf[^ۑ
//--------------------------------------------------------------------------
void SvFunction::PrintLineCnt()
{
	vecFuncGyouData.clear();

	int fmax = (int)vecFuncData.size();
	// ֐̍ŝZbg
	for(int a=0;a<fmax;a++){
		int tmp = vecFuncData[a].func_step;
		if( tmp ){
			vecFuncGyouData.push_back(tmp);
		}
	}
}

//--------------------------------------------------------------------------
// \p̊֐쐬
// Zq̃I[o[[hgꍇAoperatort
//--------------------------------------------------------------------------
std::string SvFunction::DispFuncName(FuncInfo &FuncData)
{
	std::string strNew = FuncData.strFuncName;

	if(FuncData.BitInfo & FUNC_BIT_OPERATOR){
		char *p = strrchr((char *)FuncData.strFuncName.c_str(), ':');

		if( p ){
			p++;
			int len = strNew.length() - strlen(p);
			strNew  = strNew.substr(0, len);
			strNew += "operator ";
			strNew += p;
		}
	}

	return strNew;
}

//--------------------------------------------------------------------------
// \p ()
//--------------------------------------------------------------------------
void SvFunction::TagDisp(ofstream *OutStream, char *SrcFName, int Line)
{
	char *FileP = CoutMask(SrcFName);
	int ren = TagPos - strlen(FileP);
	int ck = 0;

	if(SrcFName == NULL){
		Line = 0;
	}

	OutStream->setf(ios_base::left, ios_base::adjustfield);		// lw
	*OutStream << FileP;

	if( SpaceDisp(OutStream, ren, pSpace) ){
		*OutStream << pSpace;
	}else{
		ck = 1;
	}

	ren = Getketa(Line);						// 擾
	if( SpaceDisp(OutStream, (5-ren), pSpace) ){
		if( ck ){
			ck = 0;
			*OutStream << pSpace;
		}else{
			*OutStream << " ";
		}
	}
	if( ck ){
		ck = 0;
		*OutStream << " ";
	}
	*OutStream << Line;
	*OutStream << ": ";
}

//--------------------------------------------------------------------------
// \p (Ŋ֐c[\)
//--------------------------------------------------------------------------
void SvFunction::Print()
{
	ofstream Treelog;
	int Course[DEPTH+1];
	int aa;


	if(EpOp.FileFormat == FILE_FORMAT_HTML){
		EpOutFileOpen("EpTreeLog.html", &Treelog);
		// wb_[t@C̍쐬
		CommonHtmlHeaderOut(&Treelog, "֐c[}");		// wb_[t@Co
		Treelog << "<p><font face=\"lr SVbN\">";
	}else{
		EpOutFileOpen("EpTreeLog.txt", &Treelog);
	}

	memset(Course,  '\0',sizeof(Course));
	TagPos = 0;
	//--------------------------------------------------------------
	// ֐c[쐬̑Oɍs
	//--------------------------------------------------------------
	for(aa=0;aa<(int)vecFuncData.size();aa++){
		if(vecFuncData[aa].strFuncName.length() == 0){
			continue;
		}
		//--------------------------------------------------------------
		// ֐ύXĂꍇA"@"ȍ~폜
		//--------------------------------------------------------------
		char *FuncNameX = (char *)vecFuncData[aa].strFuncName.c_str();
		char *pp = strchr(FuncNameX, '@');
		if( pp ){
			*pp = '\0';
		}
		//--------------------------------------------------------------
		// ^O̕\ʒu擾 (Ԓt@C̒擾)
		//--------------------------------------------------------------
		char *f_len = FileNoObj->GetFileName(vecFuncData[aa].SrcFNameID);
		if( f_len ){
			if(vecFuncData[aa].BitInfo & FUNC_BIT_REGIST){
				int len = strlen(f_len);
				if(len > TagPos){
					TagPos = len;
				}
			}
		}
		//--------------------------------------------------------------
		// LȎq֐̐擾
		//--------------------------------------------------------------
		int childcnt = 0;
		int childmax = (int)vecFuncData[aa].vecChildID.size();
		for(int a2=0;a2<childmax;a2++){
			// ֐Ƃĉo^Ȃ
			if((vecFuncData[vecFuncData[aa].vecChildID[a2]].BitInfo & FUNC_BIT_REGIST) == 0){
				continue;
			}
			childcnt++;
		}
		vecFuncData[aa].ChildYukoCnt = childcnt;
	}
	//--------------------------------------------------------------
	for(aa=0;aa<(int)vecFuncData.size();aa++){
		int GetNo = vecSortData[aa];
		if(vecFuncData[GetNo].strFuncName.length() == 0){
			continue;
		}
		// ֐Ƃĉo^Ȃ
		if((vecFuncData[GetNo].BitInfo & FUNC_BIT_REGIST) == 0){
			continue;
		}
		if(vecFuncData[GetNo].vecParentID.size() == 0){		// CallĂȂ
			char *FileP = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
			int  ren   = 0;
			char *tmp_ch;
			if( EpOp.Tree_tg ){				// ^O`ŕ\Ȃ
				TagDisp(&Treelog, FileP, vecFuncData[GetNo].LineNo);
			}
			tmp_ch = (char *)vecFuncData[GetNo].strFuncName.c_str();
			ren += strlen( tmp_ch );
			Treelog << CoutMask(tmp_ch);
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
				Treelog << "(荞)" ;
				ren += 10;
			}
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
				Treelog << "(֐|C^)" ;
				ren += 14;
			}

			if( ! EpOp.Tree_tg ){
				if( SpaceDisp(&Treelog, (64-ren-2), pSpace) ){
					Treelog << pSpace << "[" ;
				}else{
					Treelog << " [" ;
				}
				Treelog << CoutMask(FileP);
				Treelog << "]" ;
			}
			if(EpOp.FileFormat == FILE_FORMAT_HTML){
				Treelog << "<br>";
			}
			Treelog << endl;
			Course[0] = GetNo;
			Print(&Treelog, GetNo, 0, Course);			// ĉA
		}
	}

	if(EpOp.FileFormat == FILE_FORMAT_HTML){
		Treelog << "</font></p>" << endl;
		Treelog << "</table>" << endl;
		Treelog << "</body>"  << endl;
		Treelog << "</html>"  << endl;
	}
	Treelog.close();							// ֐c[t@C

	// ֐ꗗ̕\
	if( EpOp.PrintFuncList ){
		switch( EpOp.FileFormat ){
		case FILE_FORMAT_TEXT:
			PrintListText();
			break;
		case FILE_FORMAT_HTML:
			PrintListHtml();
			break;
		case FILE_FORMAT_CSV:
			PrintListCsv();
			break;
		case FILE_FORMAT_XLS:
			PrintListXls();
			break;
		default:
			break;
		}
	}

	// ֐wb_[̐؂o
	if( EpOp.PrintFuncDetails ){
		switch( EpOp.FileFormat ){
		case FILE_FORMAT_TEXT:
			PrintDetailsText();
			break;
		case FILE_FORMAT_HTML:
			PrintDetailsHtml();
			break;
		case FILE_FORMAT_CSV:
			PrintDetailsCsv();
			break;
		case FILE_FORMAT_XLS:
			PrintDetailsXls();
			break;
		default:
			break;
		}
	}
}

//--------------------------------------------------------------------------
// ĉAŖ[vɊׂȂ悤ɌoH`FbN
// ̊֐ʉ߂悤Ƃ疳[vƂ
//--------------------------------------------------------------------------
int SvFunction::CheckCourseErr(int *pCourse, int depth, int bango)
{
	for(int a=0;a<=depth;a++){
		if(bango == pCourse[a])
			return 1;
	}
	pCourse[depth+1] = bango;
	return 0;
}

//--------------------------------------------------------------------------
// \p (I[o[[h)
// ĉAŕ\ڂΕ\B
// int bango  : f[^ZbgĂꏊ
// int depth  : ݂̊Kw
//--------------------------------------------------------------------------
void SvFunction::Print(ofstream *TreelogP, int bango, int depth, int *pCourse)
{
	int  Max = (int)vecFuncData[bango].vecChildID.size();
	int  WriteOne = EpOp.FuncOneDisp;				// q֐̔\
	int  SetCnt = 0;
	char *tmp_ch;


	for(int a=0;a<Max;a++){						// q֐̐
		int ren = 0;
		int NextOn = 0;
		int kaiki_NG = 0;
		int GetBango = vecFuncData[bango].vecChildID[a];

		if( CheckCourseErr(pCourse, depth, GetBango) ){
			kaiki_NG = 1;
			//continue;
		}
		// ֐Ƃĉo^Ȃ
		if((vecFuncData[GetBango].BitInfo & FUNC_BIT_REGIST) == 0){
			continue;
		}
		SetCnt++;
		char *FileP = FileNoObj->GetFileName(vecFuncData[GetBango].SrcFNameID);
		if( EpOp.Tree_tg ){					// ^O`ŕ\Ȃ
			TagDisp(TreelogP, FileP, vecFuncData[GetBango].LineNo);
		}
		*TreelogP << pSpace;

		for(int b=0;b<depth;b++){				// KwȉȂΉC
			if( skip[b] ){
				*TreelogP << pSpace;
			}else{
				*TreelogP << pBar;
			}
		}
		if(vecFuncData[bango].ChildYukoCnt == SetCnt){		// q֐͂ōŌ
			*TreelogP << pEnd;
			skip[depth] = 1;
		}else{							// q֐͂܂܂
			*TreelogP << pChoice;
			skip[depth] = 0;
		}

		tmp_ch = (char *)vecFuncData[GetBango].strFuncName.c_str();
		*TreelogP <<  tmp_ch;
		ren += strlen( tmp_ch );

		if( WriteOne && kaiki_NG==0 &&
		   (vecFuncData[GetBango].BitInfo & FUNC_BIT_OUT) ){		// q֐\ŁA\ς݂Ȃ
			if( vecFuncData[GetBango].ChildYukoCnt ){		// q֐݂鎞̂""\
				*TreelogP << "" ;
				ren += 2;
			}
		}else{
			vecFuncData[GetBango].BitInfo |= FUNC_BIT_OUT;	// qς݂Ƃ
			if(vecFuncData[GetBango].BitInfo & FUNC_BIT_POINTA){
				*TreelogP << "(֐|C^)" ;
				ren += 14;
			}
			if( kaiki_NG ){					// oH`FbNōĉAƂȂĂꍇ
				*TreelogP << "(ĉA)" ;
				ren += 8;
			}else if(vecFuncData[GetBango].BitInfo & FUNC_BIT_LOOP){	// ĉA֐Ȃ
				*TreelogP << "(ĉA)" ;
				ren += 8;
				NextOn = 1;
			}else{
				NextOn = 1;
			}
		}

		if( ! EpOp.Tree_tg ){
			if( SpaceDisp(TreelogP, (60-2*depth-ren-2), pSpace) ){
				*TreelogP << pSpace << "[" ;
			}else{
				*TreelogP << " [" ;
			}
			*TreelogP << CoutMask(FileP);
			*TreelogP << "]";
		}
		if(EpOp.FileFormat == FILE_FORMAT_HTML){
			*TreelogP << "<br>";
		}
		*TreelogP << endl;

		if(NextOn == 1){
			if(depth+1 < DEPTH)				// }u
				Print(TreelogP, GetBango, depth+1, pCourse);
		}
	}
}

//--------------------------------------------------------------------------
// ֐ꗗ̕\
//--------------------------------------------------------------------------
void SvFunction::PrintListText()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C
	int  tmp_len;
	char *tmp_ch;

	EpOutFileOpen("EpꗗFunc.txt", &FuncInfolog);

	if( EpOp.PC9801 ){						// PC-98x1
		FuncInfolog << "֐                        ESTEPE  ȆEt@C" << endl;
		FuncInfolog << "EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE" << endl;
	}else{
		FuncInfolog << "֐                        STEP  ̑t@C" << endl;
		FuncInfolog << "" << endl;
	}

	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int  ren = 0;
		int  keta;
		int  GetNo = vecSortData[aa];

		FuncInfolog.setf(ios_base::left, ios_base::adjustfield); // lw
		FuncInfolog.width(30);
		tmp_ch = (char *)vecFuncData[GetNo].strFuncName.c_str();
		if( ! tmp_ch ){
			break;
		}
		// ֐Ƃĉo^Ȃ
		if((vecFuncData[GetNo].BitInfo & FUNC_BIT_REGIST) == 0){
			continue;
		}
		ren += strlen(tmp_ch);
		if(ren > 30){
			ren -= 30;
		}else{
			ren = 0;
		}
		FuncInfolog << CoutMask(tmp_ch);			// ֐
		//-------------------------------------------------
		FuncInfolog << pBar;
		FuncInfolog.setf(ios_base::right, ios_base::adjustfield); // Elw
		keta = Getketa(vecFuncData[GetNo].func_step);
		if(ren && keta < 6){
			if((6-keta) >= ren){
				FuncInfolog.width(6-ren);
				ren = 0;
			}else{
				FuncInfolog.width(keta);
				ren -= (6-keta);
			}
		}else{
			FuncInfolog.width(6);
		}
		FuncInfolog << vecFuncData[GetNo].func_step;			// Xebv
		//-------------------------------------------------
		FuncInfolog << pBar;
		tmp_len = 6;
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			FuncInfolog << "~";
			tmp_len = 4;
		}
		FuncInfolog.setf(ios_base::right, ios_base::adjustfield); // Elw
		keta = Getketa(vecFuncData[GetNo].statck);
		if(ren && keta < tmp_len){
			if((tmp_len-keta) >= ren){
				FuncInfolog.width(tmp_len-ren);
				ren = 0;
			}else{
				FuncInfolog.width(keta);
				ren -= (tmp_len-keta);
			}
		}else{
			FuncInfolog.width(tmp_len);
		}
		FuncInfolog << vecFuncData[GetNo].statck;			// X^bNTCY
		//-------------------------------------------------
		FuncInfolog << pBar;
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
				FuncInfolog << "  " ;
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				FuncInfolog << "ց^" ;
			}else{
				FuncInfolog << "֐|" ;
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			FuncInfolog << "ĉA";
		}else{
			if(ren){
				if(ren >= 6){
					ren -= 6;
				}else{
					FuncInfolog.width(6-ren);
					FuncInfolog << " ";
					ren = 0;
				}
			}else{
				FuncInfolog << "      ";
			}
		}
		//-------------------------------------------------
		FuncInfolog << pBar;
		tmp_ch = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
		FuncInfolog << CoutMask(tmp_ch);			// \[Xt@C

		FuncInfolog << endl;
	}
	FuncInfolog.close();						// t@C
}

//--------------------------------------------------------------------------
// ֐ꗗ̕\
//--------------------------------------------------------------------------
void SvFunction::PrintListHtml()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C

	EpOutFileOpen("EpꗗFunc.html", &FuncInfolog);

	// wb_[t@C̍쐬
	CommonHtmlHeaderOut(&FuncInfolog, "֐ꗗ");			// wb_[t@Co

	FuncInfolog << "<table border=\"1\" cellpadding=\"5\" width=\"800\">" << endl;

	// 
	FuncInfolog << "    <tr>" << endl;
	CommonHtmlTableTitle(&FuncInfolog, "35%", "֐");
	CommonHtmlTableTitle(&FuncInfolog, "10%", "STEP");
	CommonHtmlTableTitle(&FuncInfolog, "10%" , "");
	CommonHtmlTableTitle(&FuncInfolog, "10%" , "̑");
	CommonHtmlTableTitle(&FuncInfolog, "35%", "t@C");
	FuncInfolog << "    </tr>" << endl;

	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int GetNo = vecSortData[aa];
		// ֐Ƃĉo^Ȃ
		if((vecFuncData[GetNo].BitInfo & FUNC_BIT_REGIST) == 0){
			continue;
		}
		FuncInfolog << "    <tr>" << endl;
		// ֐
		CommonHtmlTableStr(&FuncInfolog, "35%", (char *)vecFuncData[GetNo].strFuncName.c_str());
		// Xebv
		CommonHtmlTableData(&FuncInfolog, "10%", vecFuncData[GetNo].func_step);
		//-------------------------------------------------
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			FuncInfolog << "        <td align=\"right\" valign=\"top\" width=\"10%\">";
			FuncInfolog << "~ " << vecFuncData[GetNo].statck << "</td>" << endl;
		}else{
			CommonHtmlTableData(&FuncInfolog, "10%", vecFuncData[GetNo].statck);	// X^bNTCY
		}
		//-------------------------------------------------
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
				CommonHtmlTableStr(&FuncInfolog, "10%", "@");
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				CommonHtmlTableStr(&FuncInfolog, "10%", "֐߲/ĉA");
			}else{
				CommonHtmlTableStr(&FuncInfolog, "10%", "֐߲");
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			CommonHtmlTableStr(&FuncInfolog, "10%", "ĉA");
		}else{
			CommonHtmlTableStr(&FuncInfolog, "10%", "@");
		}
		//-------------------------------------------------
		CommonHtmlTableStr(&FuncInfolog, "35%", 		// \[Xt@C
			FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID));
		//----------------------------------------------
		FuncInfolog << "    </tr>" << endl;
	}

	// t@C̏I
	FuncInfolog << "</table>" << endl;
	FuncInfolog << "</body>"  << endl;
	FuncInfolog << "</html>"  << endl;
	FuncInfolog.close();						// t@C
}

//--------------------------------------------------------------------------
// ֐ꗗ̕\
//--------------------------------------------------------------------------
void SvFunction::PrintListCsv()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C
	char *tmp_ch;

	EpOutFileOpen("EpꗗFunc.csv", &FuncInfolog);

	FuncInfolog << "֐,STEP,,̑,t@C" << endl;

	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int  GetNo = vecSortData[aa];

		// ֐Ƃĉo^Ȃ
		if((vecFuncData[GetNo].BitInfo & FUNC_BIT_REGIST) == 0){
			continue;
		}
		FuncInfolog << vecFuncData[GetNo].strFuncName.c_str() << ",";	// ֐
		//-------------------------------------------------
		FuncInfolog << vecFuncData[GetNo].func_step << ",";		// Xebv
		//-------------------------------------------------
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			FuncInfolog << "~";
		}
		FuncInfolog << vecFuncData[GetNo].statck    << ",";		// X^bNTCY
		//-------------------------------------------------
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
			FuncInfolog << "荞,";
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				FuncInfolog << "֐߲/ĉA,";
			}else{
				FuncInfolog << "֐߲,";
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			FuncInfolog << "ĉA,";
		}else{
			FuncInfolog << ",";
		}
		//-------------------------------------------------
		tmp_ch = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
		FuncInfolog << CoutMask(tmp_ch);			// \[Xt@C
		FuncInfolog << endl;
	}
	FuncInfolog.close();						// t@C
}


//--------------------------------------------------------------------------
// ֐ꗗ̕\
//--------------------------------------------------------------------------
void SvFunction::PrintListXls()
{
extern	void	DrawKeisen_FuncList(int max);
	int		aa;
	char		*tmp_ch;
	char		stk_buf[20];
	HRESULT		hr;
	_variant_t	vSet;
	char		strEria[40];
	long		index[2];
	long		SetCnt;
	SAFEARRAYBOUND	sabound[2];
	SAFEARRAY	*psa;
	VARIANT		vResult;


	try{
		vResult.vt = VT_ARRAY|VT_VARIANT;

		//---------------t@CI[v---------------------------
		Excel_Open();

		// V[gύX
		Excel_PutSheetName("֐ꗗ");

		sprintf(strEria, "A1:E%d", (int)vecFuncData.size()+1);

		sabound[0].cElements = (int)vecFuncData.size()+1;	// š
		sabound[0].lLbound   = 0;
		sabound[1].cElements = 5;				// ̌
		sabound[1].lLbound   = 0;
		// ̈mۂ
		psa = SafeArrayCreate(VT_VARIANT, 2, sabound);

		unsigned char *rgElems;
		hr = SafeArrayAccessData(psa, (void **)&rgElems);

		index[0] = 0;						// sԍ
		index[1] = 0;						// ԍ
		vSet = "֐";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 1;						// ԍ
		vSet = "STEP";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 2;						// ԍ
		vSet = "";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 3;						// ԍ
		vSet = "̑";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 4;						// ԍ
		vSet = "t@C";
		SafeArrayPutElement(psa, index, &vSet);

		SetCnt = 1;
		for(aa=0;aa<(int)vecFuncData.size();aa++){
			int  GetNo = vecSortData[aa];
			index[0] = SetCnt;				// sԍ

			// ֐Ƃĉo^Ȃ
			if((vecFuncData[GetNo].BitInfo & FUNC_BIT_REGIST) == 0){
				continue;
			}

			// ֐
			index[1] = 0;					// ԍ
			vSet.SetString((char *)vecFuncData[GetNo].strFuncName.c_str());
			vSet.ChangeType(VT_BSTR);
			SafeArrayPutElement(psa, index, &vSet);
			// Xebv
			index[1] = 1;					// ԍ
			vSet.intVal = vecFuncData[GetNo].func_step;
			vSet.vt = VT_I4;
			SafeArrayPutElement(psa, index, &vSet);
			//-------------------------------------------------
			// X^bNTCY
			index[1] = 2;					// ԍ
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){	// X^bNTCY̌vsmȏꍇ
				sprintf(stk_buf, "~ %d", vecFuncData[GetNo].statck);
			}else{
				sprintf(stk_buf, "%d", vecFuncData[GetNo].statck);
			}
			vSet.SetString(stk_buf);
			vSet.ChangeType(VT_BSTR);
			SafeArrayPutElement(psa, index, &vSet);
			//-------------------------------------------------
			index[1] = 3;					// ԍ
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
				vSet.SetString("荞");
			}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
				if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
					vSet.SetString("֐߲/ĉA");
				}else{
					vSet.SetString("֐߲");
				}
			}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				vSet.SetString("ĉA");
			}else{
				vSet.SetString("");
			}
			vSet.ChangeType(VT_BSTR);
			SafeArrayPutElement(psa, index, &vSet);
			//-------------------------------------------------
			index[1] = 4;					// ԍ
			tmp_ch = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
			if(tmp_ch == NULL){
				tmp_ch = "";
			}
			vSet.SetString(tmp_ch);
			vSet.ChangeType(VT_BSTR);
			SafeArrayPutElement(psa, index, &vSet);
			SetCnt++;
		}

		// SAFEARRAY|C^ݒ
		V_ARRAY(&vResult) = psa;
		// 쐬f[^ꊇē\t
		 Excel_PasteSel(strEria, vResult);
		// SAFEARRAYJ
		SafeArrayUnaccessData(psa);

		DrawKeisen_FuncList(SetCnt);				// r

	}catch(...){
	}

}


//--------------------------------------------------------------------------
// ֐ڍ׏̕\
//--------------------------------------------------------------------------
void SvFunction::PrintDetailsText()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C

	EpOutFileOpen("Ep֐ڍ׏.txt", &FuncInfolog);


	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int  GetNo = vecSortData[aa];

		char *pSrcName = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
		if( ! pSrcName ){
			continue;
		}

		FuncInfolog << vecFuncData[GetNo].strComment.c_str();

		FuncInfolog << "֐@@@F" << DispFuncName(vecFuncData[GetNo]).c_str() << endl;
		FuncInfolog << "֐̌^@@F" << vecFuncData[GetNo].strType.c_str() << endl;
		FuncInfolog << "֐̈@F" << vecFuncData[GetNo].strArg.c_str() << endl;
		FuncInfolog << "\[X@@@F" ;
		if( pSrcName ){
			FuncInfolog << pSrcName << "  " << vecFuncData[GetNo].LineNo << " :s";
		}
		FuncInfolog << endl;
		FuncInfolog << "Xebv@F" << vecFuncData[GetNo].func_step << endl;
		FuncInfolog << "gpX^bNF";
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			FuncInfolog << "~";
		}
		FuncInfolog << vecFuncData[GetNo].statck << endl;		// X^bNTCY
		FuncInfolog << "l@@@@F";
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
			FuncInfolog << "荞" ;
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				FuncInfolog << "֐|C^^ĉA" ;
			}else{
				FuncInfolog << "֐|C^" ;
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			FuncInfolog << "ĉA";
		}
		FuncInfolog << endl;
		if( vecFuncData[GetNo].vecParentID.size() ){
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecParentID.size();cc++){
				if(cc == 0){
					FuncInfolog << "e֐@@@F";
				}else{
					FuncInfolog << "@@@@@@@F";
				}
				int ParentNo = vecFuncData[GetNo].vecParentID[cc];
				FuncInfolog << DispFuncName(vecFuncData[ParentNo]).c_str() << endl;
			}
		}
		if( vecFuncData[GetNo].ChildYukoCnt ){			// LȎq֐
			int SetCnt = 0;
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecChildID.size();cc++){
				int childNo = vecFuncData[GetNo].vecChildID[cc];
				// ֐Ƃĉo^Ȃ
				if((vecFuncData[childNo].BitInfo & FUNC_BIT_REGIST) == 0){
					continue;
				}
				if(SetCnt == 0){
					FuncInfolog << "q֐@@@F";
				}else{
					FuncInfolog << "@@@@@@@F";
				}
				FuncInfolog << DispFuncName(vecFuncData[childNo]).c_str() << endl;
				SetCnt++;
			}
		}
		if( vecFuncData[GetNo].vecRabelstr.size() ){
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecRabelstr.size();cc++){
				if(cc == 0){
					FuncInfolog << "Qƕϐ@@F";
				}else{
					FuncInfolog << "@@@@@@@F";
				}
				FuncInfolog << vecFuncData[GetNo].vecRabelstr[cc].c_str() << endl;
			}
		}
		//-------------------------------------------------
		FuncInfolog << endl;
		FuncInfolog << endl;
		FuncInfolog << endl;
	}
	FuncInfolog.close();						// t@C
}


//--------------------------------------------------------------------------
// ֐ڍ׏̕\
//--------------------------------------------------------------------------
void SvFunction::PrintDetailsCsv()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C

	EpOutFileOpen("Ep֐ڍ׏.csv", &FuncInfolog);


	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int  GetNo = vecSortData[aa];

		char *pSrcName = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
		if( ! pSrcName ){
			continue;
		}

		FuncInfolog << vecFuncData[GetNo].strComment.c_str();
		FuncInfolog << "֐," << DispFuncName(vecFuncData[GetNo]).c_str() << endl;
		FuncInfolog << "֐̌^," << vecFuncData[GetNo].strType.c_str() << endl;
		FuncInfolog << "֐̈," << vecFuncData[GetNo].strArg.c_str() << endl;
		FuncInfolog << "\[X," ;
		if( pSrcName ){
			FuncInfolog << pSrcName << "," << vecFuncData[GetNo].LineNo;
		}
		FuncInfolog << endl;
		FuncInfolog << "Xebv," << vecFuncData[GetNo].func_step << endl;
		FuncInfolog << "gpX^bN,";
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			FuncInfolog << "~";
		}
		FuncInfolog << vecFuncData[GetNo].statck << endl;		// X^bNTCY
		FuncInfolog << "l,";
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
			FuncInfolog << "荞" ;
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				FuncInfolog << "֐|C^^ĉA" ;
			}else{
				FuncInfolog << "֐|C^" ;
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			FuncInfolog << "ĉA";
		}
		FuncInfolog << endl;
		if( vecFuncData[GetNo].vecParentID.size() ){
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecParentID.size();cc++){
				if(cc == 0){
					FuncInfolog << "e֐,";
				}
				int ParentNo = vecFuncData[GetNo].vecParentID[cc];
				FuncInfolog << DispFuncName(vecFuncData[ParentNo]).c_str() << ",";
			}
			FuncInfolog << endl;
		}
		if( vecFuncData[GetNo].ChildYukoCnt ){			// LȎq֐
			int SetCnt = 0;
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecChildID.size();cc++){
				int childNo = vecFuncData[GetNo].vecChildID[cc];
				// ֐Ƃĉo^Ȃ
				if((vecFuncData[childNo].BitInfo & FUNC_BIT_REGIST) == 0){
					continue;
				}
				if(SetCnt == 0){
					FuncInfolog << "q֐,";
				}
				FuncInfolog << DispFuncName(vecFuncData[childNo]).c_str() << ",";
				SetCnt++;
			}
			FuncInfolog << endl;
		}
		if( vecFuncData[GetNo].vecRabelstr.size() ){
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecRabelstr.size();cc++){
				if(cc == 0){
					FuncInfolog << "Qƕϐ,";
				}
				FuncInfolog << vecFuncData[GetNo].vecRabelstr[cc].c_str() << ",";
			}
			FuncInfolog << endl;
		}
		//-------------------------------------------------
		FuncInfolog << endl;
		FuncInfolog << endl;
	}
	FuncInfolog.close();						// t@C
}


//--------------------------------------------------------------------------
// ֐ڍ׏̕\
//--------------------------------------------------------------------------
void SvFunction::PrintDetailsHtml()
{
	ofstream FuncInfolog;						// ֐̏o͗pt@C
	char buf[50];
	char *p;

	EpOutFileOpen("Ep֐ڍ׏.html", &FuncInfolog);


	// wb_[t@C̍쐬
	CommonHtmlHeaderOut(&FuncInfolog, "֐ڍ׏");		// wb_[t@Co


	for(int aa=0;aa<(int)vecFuncData.size();aa++){
		int  GetNo = vecSortData[aa];

		char *pSrcName = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
		if( ! pSrcName ){
			continue;
		}

		FuncInfolog << "<table border=\"1\" cellpadding=\"2\" width=\"800\">" << endl;

		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		FuncInfolog << "        <th align=\"left\" valign=\"top\" colspan=\"2\">";
		p = (char *)vecFuncData[GetNo].strComment.c_str();
		if(*p == '\0'){
			FuncInfolog << "@";
		}else{
			FuncInfolog << "<pre>" << p << "</pre>" << endl;
		}
		FuncInfolog << "</th>" << endl;
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "֐");
		CommonHtmlTableStr(&FuncInfolog, "80%", (char *)DispFuncName(vecFuncData[GetNo]).c_str());
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "֐̌^");
		p = (char *)vecFuncData[GetNo].strType.c_str();
		if(*p == '\0'){
			p = "@";
		}
		CommonHtmlTableStr(&FuncInfolog, "80%", p);
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "֐̈");
		p = (char *)vecFuncData[GetNo].strArg.c_str();
		if(*p == '\0'){
			p = "@";
		}
		CommonHtmlTableStr(&FuncInfolog, "80%", p);
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "\[X");
		if( pSrcName ){
			FuncInfolog << "        <td valign=\"top\" width=\"80%\">";
			itoa(vecFuncData[GetNo].LineNo, buf, 10);
			FuncInfolog << pSrcName << " " << buf << "s</td>" << endl;
		}else{
			CommonHtmlTableStr(&FuncInfolog, "80%", "@");
		}
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "Xebv");
		sprintf(buf, "%d", vecFuncData[GetNo].func_step);
		CommonHtmlTableStr(&FuncInfolog, "80%", buf);
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "gpX^bN");
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
			sprintf(buf, "~%d", vecFuncData[GetNo].statck);
		}else{
			sprintf(buf, "%d", vecFuncData[GetNo].statck);
		}
		CommonHtmlTableStr(&FuncInfolog, "80%", buf);
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		FuncInfolog << "    <tr>" << endl;
		CommonHtmlTableStr(&FuncInfolog, "20%", "l");
		if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
			p = "荞" ;
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				p = "֐|C^^ĉA" ;
			}else{
				p = "֐|C^" ;
			}
		}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
			p = "ĉA";
		}else{
			p = "@";
		}
		CommonHtmlTableStr(&FuncInfolog, "80%", p);
		FuncInfolog << "    </tr>" << endl;
		//-------------------------------------------------
		if( vecFuncData[GetNo].vecParentID.size() ){
			FuncInfolog << "    <tr>" << endl;
			CommonHtmlTableStr(&FuncInfolog, "20%", "e֐");
			FuncInfolog << "        <td valign=\"top\" width=\"80%\">";
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecParentID.size();cc++){
				int ParentNo = vecFuncData[GetNo].vecParentID[cc];
				FuncInfolog << DispFuncName(vecFuncData[ParentNo]).c_str();
				if(cc+1 < (int)vecFuncData[GetNo].vecParentID.size()){
					FuncInfolog << "<br>";
				}
			}
			FuncInfolog << "</td>" << endl;
			FuncInfolog << "    </tr>" << endl;
		}
		//-------------------------------------------------
		if( vecFuncData[GetNo].ChildYukoCnt ){			// LȎq֐
			FuncInfolog << "    <tr>" << endl;
			CommonHtmlTableStr(&FuncInfolog, "20%", "q֐");
			FuncInfolog << "        <td valign=\"top\" width=\"80%\">";
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecChildID.size();cc++){
				int childNo = vecFuncData[GetNo].vecChildID[cc];
				// ֐Ƃĉo^Ȃ
				if((vecFuncData[childNo].BitInfo & FUNC_BIT_REGIST) == 0){
					continue;
				}
				FuncInfolog << DispFuncName(vecFuncData[childNo]).c_str();
				if(cc+1 < (int)vecFuncData[GetNo].vecChildID.size()){
					FuncInfolog << "<br>";
				}
			}
			FuncInfolog << "</td>" << endl;
			FuncInfolog << "    </tr>" << endl;
		}
		//-------------------------------------------------
		if( vecFuncData[GetNo].vecRabelstr.size() ){
			FuncInfolog << "    <tr>" << endl;
			CommonHtmlTableStr(&FuncInfolog, "20%", "Qƕϐ");
			FuncInfolog << "        <td valign=\"top\" width=\"80%\">";
			for(int cc=0;cc<(int)vecFuncData[GetNo].vecRabelstr.size();cc++){
				FuncInfolog << vecFuncData[GetNo].vecRabelstr[cc].c_str();
				if(cc+1 < (int)vecFuncData[GetNo].vecRabelstr.size()){
					FuncInfolog << "<br>";
				}
			}
			FuncInfolog << "</td>" << endl;
			FuncInfolog << "    </tr>" << endl;
		}
		//-------------------------------------------------
		FuncInfolog << "</table>" << endl;
		FuncInfolog << "<br>" << endl;
		FuncInfolog << "<br>" << endl;
	}
	FuncInfolog << "</body>"  << endl;
	FuncInfolog << "</html>"  << endl;

	FuncInfolog.close();						// t@C
}


//--------------------------------------------------------------------------
// ֐ڍ׏̕\
//--------------------------------------------------------------------------
void SvFunction::PrintDetailsXls()
{
extern	void	DrawKeisen_FuncDetails(int, int);
const	int		LineCnt = 13;
	int		aa;
	int		cc;
	int		SetCnt = 0;
	char		*tmp_p;
	char		buf[20];
	HRESULT		hr;
	_variant_t	vSet;
	char		strEria[40];
	long		index[2];
	SAFEARRAYBOUND	sabound[2];
	SAFEARRAY	*psa;
	VARIANT		vResult;
	string		tmp_str;

	try{
		vResult.vt = VT_ARRAY|VT_VARIANT;

		//---------------t@CI[v---------------------------
		Excel_Open();

		// V[gύX
		Excel_PutSheetName("֐ڍ׏");

		sabound[0].cElements = (int)vecFuncData.size()*LineCnt;	// š
		sabound[0].lLbound   = 0;
		sabound[1].cElements = 2+1;				// ̌ (BZ1)
		sabound[1].lLbound   = 0;
		// ̈mۂ
		psa = SafeArrayCreate(VT_VARIANT, 2, sabound);

		unsigned char *rgElems;
		hr = SafeArrayAccessData(psa, (void **)&rgElems);


		for(aa=0;aa<(int)vecFuncData.size();aa++){
			int  GetNo = vecSortData[aa];

			char *pSrcName = FileNoObj->GetFileName(vecFuncData[GetNo].SrcFNameID);
			if( ! pSrcName ){
				continue;
			}

			int base = SetCnt*LineCnt;

			index[1] = 0;					// ԍ
			index[0] = base;				// sԍ
			vSet = "";
			vSet.vt = VT_BSTR;
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+1;				// sԍ
			vSet = "֐";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+2;				// sԍ
			vSet = "֐̌^";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+3;				// sԍ
			vSet = "֐̈";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+4;				// sԍ
			vSet = "\[X";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+5;				// sԍ
			vSet = "Xebv";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+6;				// sԍ
			vSet = "gpX^bN";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+7;				// sԍ
			vSet = "l";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+8;				// sԍ
			vSet = "e֐";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+9;				// sԍ
			vSet = "q֐";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+10;				// sԍ
			vSet = "Qƕϐ";
			SafeArrayPutElement(psa, index, &vSet);
			// ȉAs
			index[0] = base+11;				// sԍ
			vSet = "";
			SafeArrayPutElement(psa, index, &vSet);
			index[0] = base+12;				// sԍ
			vSet = "";
			SafeArrayPutElement(psa, index, &vSet);

			//-------------------------------------------------
			index[1] = 1;					// ԍ
			// ֐̃wb_
			index[0] = base;				// sԍ
			tmp_str  = "\'";
			int CrCnt = 0;
			char *p = (char *)vecFuncData[GetNo].strComment.c_str();
			for(;;p++){					// Ōɂs菜
				if(p == NULL){
					break;
				}else if(*p == 0x0a){
					CrCnt++;
				}else if(*p == '\0'){
					if(*(p-1) == 0x0a){
						*(p-1) = '\0';
						CrCnt--;
					}
					break;
				}
			}
			tmp_str += vecFuncData[GetNo].strComment.c_str();
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// ֐
			index[0] = base+1;				// sԍ
			vSet = (char *)DispFuncName(vecFuncData[GetNo]).c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// ֐̌^
			index[0] = base+2;				// sԍ
			vSet = (char *)vecFuncData[GetNo].strType.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// ֐̈
			index[0] = base+3;				// sԍ
			vSet = (char *)vecFuncData[GetNo].strArg.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// \[Xt@C
			index[0] = base+4;				// sԍ
			tmp_str = pSrcName;
			sprintf(buf, "  %d s", vecFuncData[GetNo].LineNo);
			tmp_str += buf;
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// XebvZbg
			index[0] = base+5;				// sԍ
			sprintf(buf, "\'%d", vecFuncData[GetNo].func_step);
			vSet = buf;
			SafeArrayPutElement(psa, index, &vSet);
			// X^bNTCYZbg
			index[0] = base+6;				// sԍ
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_STK_ERR){		// X^bNTCY̌vsmȏꍇ
				sprintf(buf, "~%d", vecFuncData[GetNo].statck);
			}else{
				sprintf(buf, "\'%d", vecFuncData[GetNo].statck);
			}
			vSet = buf;
			SafeArrayPutElement(psa, index, &vSet);
			// lZbg
			if(vecFuncData[GetNo].BitInfo & FUNC_BIT_INTERRUPT){
				tmp_p = "荞" ;
			}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_POINTA){
				if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
					tmp_p = "֐|C^^ĉA" ;
				}else{
					tmp_p = "֐|C^" ;
				}
			}else if(vecFuncData[GetNo].BitInfo & FUNC_BIT_LOOP){
				tmp_p = "ĉA";
			}else{
				tmp_p = "";
			}
			index[0] = base+7;				// sԍ
			vSet = tmp_p;
			SafeArrayPutElement(psa, index, &vSet);
			// ֐̐e
			index[0] = base+8;				// sԍ
			tmp_str = "";
			for(cc=0;cc<(int)vecFuncData[GetNo].vecParentID.size();cc++){
				int ParentNo = vecFuncData[GetNo].vecParentID[cc];
				tmp_str += DispFuncName(vecFuncData[ParentNo]);
				if(cc+1 < (int)vecFuncData[GetNo].vecParentID.size()){
					tmp_str += "\n";
				}
			}
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// ֐̎q
			index[0] = base+9;				// sԍ
			tmp_str = "";
			for(cc=0;cc<(int)vecFuncData[GetNo].vecChildID.size();cc++){
				int childNo = vecFuncData[GetNo].vecChildID[cc];
				// ֐Ƃĉo^Ȃ
				if((vecFuncData[childNo].BitInfo & FUNC_BIT_REGIST) == 0){
					continue;
				}
				tmp_str += DispFuncName(vecFuncData[childNo]);
				if(cc+1 < (int)vecFuncData[GetNo].vecChildID.size()){
					tmp_str += "\n";
				}
			}
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			// Qƕϐ
			index[0] = base+10;				// sԍ
			tmp_str = "";
			for(cc=0;cc<(int)vecFuncData[GetNo].vecRabelstr.size();cc++){
				tmp_str += vecFuncData[GetNo].vecRabelstr[cc];
				if(cc+1 < (int)vecFuncData[GetNo].vecRabelstr.size()){
					tmp_str += "\n";
				}
			}
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);
			//-------------------------------------------------
			index[1] = 2;					// ԍ
			// ֐̃wb_̉BZ
			index[0] = base;				// sԍ
			tmp_str  = "\'";
			for(cc=0;cc<CrCnt;cc++){
				tmp_str += "\n";
			}
			vSet = tmp_str.c_str();
			SafeArrayPutElement(psa, index, &vSet);

			SetCnt++;
		}

		// SAFEARRAY|C^ݒ
		V_ARRAY(&vResult) = psa;
		// 쐬f[^ꊇē\t
		sprintf(strEria, "A1:C%d", (int)vecFuncData.size()*LineCnt);
		Excel_PasteSel(strEria, vResult);
		// SAFEARRAYJ
		SafeArrayUnaccessData(psa);

		DrawKeisen_FuncDetails(SetCnt, LineCnt);		// r

	}catch(...){
	}

}


