#include	<windows.h>
#include	<commctrl.h>
#include	<iostream>
#include	<fstream>
#include	<vector>
using namespace std;
#include	<comdef.h>
#include	"common.h"
#include	"SvFileStack.h"
#include	"SvType.h"
#include	"SvFunction.h"
#include	"SvClass.h"
#include	"SvFileNo.h"



extern	SvFunction	*FuncObj;						// ֐o^pIuWFNg
extern	SvType		*TypeObj;						// ^i[ĂIuWFNg
extern	SvFileStack	*FileStackObj;						// ݏ̃t@Ci[IuWFNg
extern	SvFileNo	*FileNoObj;						// t@C̕ۑpIuWFNg


//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
SvClass::SvClass()
{
	FileOpenCnt= 0;								// o͗p̃t@CJ
	xls_line= 1;
}

//--------------------------------------------------------------------------
// fXgN^
//--------------------------------------------------------------------------
SvClass::~SvClass()
{
}

//--------------------------------------------------------------------------
// f[^̏
// IuWFNg̐Ajɂ͎ԂׁAxmۂ
// GA͉ȂB
//--------------------------------------------------------------------------
void SvClass::Init()
{
	if(FileStackObj->SrcLang() & (MASK_BIT_VB|MASK_BIT_DELPHI)){
		// VBADelphi̓wb_[t@Cߏɕێ
		for(int a=0;a<(int)vecClassData.size();a++){
			vecClassData[a].UseClassCk = 0;				// gptOOFFɂ
		}
		return;
	}

	vecClassData.clear();
}

//--------------------------------------------------------------------------
// NXZbg
// iClassType  0:NX  1:\
//--------------------------------------------------------------------------
void SvClass::Class_Set(std::string &strClassName, int UseCheck, int iClassType)
{
	int  SetPos;
	int  lang = FileStackObj->SrcLang();
	int  iObjType = OBJ_TYPE_CLASS;


	if(strClassName.length() == 0){
		return;
	}

	if( Search((char *)strClassName.c_str(), &SetPos) ){
		if(iClassType == 0){
			cerr << "  " << strClassName.c_str() << "͊ɓo^ς݂ł[class]" << endl;
		}
		return;
	}

	// f[^̌^ۑ
	if(iClassType == 1){
		iObjType = OBJ_TYPE_STRUCT;
	}
	if(*strClassName.c_str() != '@'){
		// \̂̉o^͒e
		TypeObj->SetData((char *)strClassName.c_str(), iObjType, 0, 0);
	}

	// o^p̃NXf[^쐬
	ClassInfo tmpClass;
	tmpClass.ClassType = iClassType;
	tmpClass.ClassName = strClassName;
	tmpClass.SrcFNameID = FileNoObj->SetData( FileStackObj->GetFileName() );
	tmpClass.Lang = lang;
	tmpClass.UseClassCk = UseCheck;
	tmpClass.StackSize = 0;
	tmpClass.StackErr = 0;

	if((int)vecClassData.size() > SetPos){
		vecClassData.insert(vecClassData.begin()+SetPos, tmpClass);
	}else{
		vecClassData.push_back(tmpClass);
	}
}


//--------------------------------------------------------------------------
// NXgpǂ
// char *clname    : IuWFNg̃NX
//--------------------------------------------------------------------------
void SvClass::Class_UseCheck(char *clname)
{
	int SetPos;

	if( ! clname ){
		return;
	}

	if( Search(clname, &SetPos) ){
		vecClassData[SetPos].UseClassCk = 1;
	}
}

//--------------------------------------------------------------------------
// NX`Ă邩ǂ
// ߂l 1: `Ă
//        0: `ĂȂ
//--------------------------------------------------------------------------
int SvClass::SearchTrueClass(char *clname)
{
	int SetPos;
	int ret = Search(clname, &SetPos);

	if( ret ){
		// \̂̏ꍇ
		if( vecClassData[SetPos].ClassType ){
			return 0;
		}
	}

	return ret;
}
//--------------------------------------------------------------------------
// NX`Ă邩ǂ
// ߂l 1: `Ă
//        0: `ĂȂ
//--------------------------------------------------------------------------
int SvClass::Search(char *clname)
{
	int SetPos;
	int ret = Search(clname, &SetPos);

	return ret;
}

//--------------------------------------------------------------------------
// NX`Ă邩ǂ
// ߂l 1: `Ă
//        0: `ĂȂ
//--------------------------------------------------------------------------
int SvClass::Search(char *clname, int *SetPos)
{
	int max = (int)vecClassData.size()-1;					// zɕϊ
	int min = 0;
	int half= 0;
	int result;

	if(clname == NULL || *clname == '\0'){
		return 0;
	}

	std::string strCLName = clname;

	char *new_p = strchr(clname, '<');
	if( new_p ){
		strCLName = strCLName.substr(0, (new_p-clname));
	}

	if( vecClassData.size() ){
		while(1){
			half = (min+max)/2;					// ̒n_
			if(vecClassData[half].ClassName.length() == 0){
				cerr << "classɂĈُ킪܂(װ)" << endl;
				break;
			}
			result = MyFunc_strcmp((char *)strCLName.c_str(), (char *)vecClassData[half].ClassName.c_str());
			if( result == 0 ){
				*SetPos = half;
				int lang = FileStackObj->SrcLang();
				return (vecClassData[half].Lang & lang);
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{							// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}
	*SetPos = half;
	return 0;
}


//--------------------------------------------------------------------------
// NXɃ\bh(֐)ZbgB
//--------------------------------------------------------------------------
void SvClass::SetMessod(FuncParam &Param)
{
	int SetPos;

	if(Param.strClassName.length() == 0){
		return;
	}

	if(Search((char *)Param.strClassName.c_str(), &SetPos) == 0){		// NXo^ĂȂ!!
		cerr << "o^׽["<<  Param.strClassName.c_str() << "]ɑ΂ҿޓo^[";
		cerr <<  Param.strFuncName.c_str() << "]悤ƂĂ܂(װ)" << endl;
		Class_Set(Param.strClassName);
	}

	// \bhɓo^Ă邩ǂ
	int messod_max = (int)vecClassData[SetPos].vecMessod.size();
	for(int b=0; b<messod_max ; b++){
		if(MyFunc_strcmp((char *)Param.strFuncName.c_str(),
				(char *)vecClassData[SetPos].vecMessod[b].c_str()) == 0){
			return ;
		}
	}

	vecClassData[SetPos].vecMessod.push_back(Param.strFuncName);
}

//--------------------------------------------------------------------------
// psꍇɌpNX̖OۑB
// clname  : ݒ蒆̃NX
// KihonCL : ps{NX
//--------------------------------------------------------------------------
void SvClass::SetKeishyou(std::string &strCLName, char *kihonCL)
{
	int SetPos;

	if(strCLName.length() == 0){
		return;
	}

	if(Search((char *)strCLName.c_str(), &SetPos) == 0){
		cerr << "׽[" << strCLName.c_str() << "]ɂČpsƂ܂A";
		cerr << "{׽[" << CoutMask(kihonCL) << "]o^Ă܂(װ)" << endl;
		return;
	}

	int tmp_max = (int)vecClassData[SetPos].vecKeishyou.size();
	for(int b=0;b<tmp_max;b++){						// {NXo^B
		char *KeishyouX = (char *)vecClassData[SetPos].vecKeishyou[b].c_str();
		if(MyFunc_strcmp(KeishyouX, kihonCL) == 0){			// ɃNXo^Ă
			return;
		}
	}

	std::string strKihonCL = kihonCL;
	vecClassData[SetPos].vecKeishyou.push_back(strKihonCL);
}

//--------------------------------------------------------------------------
// NX̌pɂĖ[vɊׂȂ悤Ƀ`FbNB
// ߂l  0F
//         1FzQƂɂȂ
//--------------------------------------------------------------------------
int SvClass::CheckkeishyouErr(std::vector<int> &vecCourse, int bango)
{
	for(int a=0;a<(int)vecCourse.size();a++){				// p`FbN
		if(vecCourse[a] == bango){					// z[vɊׂ
			cerr << "{׽ɂĖٰ߂Ɋׂ܂B" << endl;
			return 1;
		}
	}
	vecCourse.push_back(bango);						// ֐o^ԍۑ

	return 0;
}

//--------------------------------------------------------------------------
// \bhĂ{NX擾B
// [v`FbN@\t
//--------------------------------------------------------------------------
char *SvClass::GetBaseClass(std::string &strCLName, std::string &messod)
{
	std::vector<int> vecCourse;

	char *KihonClassName = GetBaseClass(strCLName, messod, vecCourse);

	return KihonClassName;
}

//--------------------------------------------------------------------------
// \bhĂ{NX擾B
// [v`FbN@\t
//--------------------------------------------------------------------------
char *SvClass::GetBaseClass(std::string &strCLName, std::string &messod,
		std::vector<int> &vecCourse)
{
	int SetPos;

	if(strCLName.length() == 0){
		return "";
	}

	if(Search((char *)strCLName.c_str(), &SetPos) == 0){			// NX`ĂȂ
		return "";
	}else if( CheckkeishyouErr(vecCourse, SetPos) ){			// [vɊׂĂ
		return "";
	}

	// NX̃\bhǂׂ
	int tmp_max = (int)vecClassData[SetPos].vecMessod.size();
	for(int b=0;b<tmp_max;b++){ 						// \bho^ĂΊ{NXԂ
		char *MessodX = (char *)vecClassData[SetPos].vecMessod[b].c_str();
		if(MyFunc_strcmp(MessodX, messod.c_str()) == 0){
			return (char *)vecClassData[SetPos].ClassName.c_str();
		}
	}
	// NX̃\bhłȂꍇ͌p𒲂ׂ
	tmp_max = (int)vecClassData[SetPos].vecKeishyou.size();
	for(int c=0;c<tmp_max;c++){
		char *getName = GetBaseClass(vecClassData[SetPos].vecKeishyou[c],
				messod, vecCourse);
		if(*getName != '\0'){						// NXԂꂽ
			return getName;
		}
	}
	vecCourse.erase(vecCourse.begin()+vecCourse.size()-1);			// łȂ̂ŊKw߂

	return "";
}

//--------------------------------------------------------------------------
// pNXԂ
// SearchCL : pNX
// bango    : wNX̌p(o^ԍ)
//--------------------------------------------------------------------------
char *SvClass::GetKeishyou(char *SearchCL, int bango)
{
	int SetPos;

	if( ! SearchCL || *SearchCL == '\0'){
		return "";
	}

	if(Search(SearchCL, &SetPos) == 0){					// NX̂o^ĂȂ
		return "";
	}

	if((int)vecClassData[SetPos].vecKeishyou.size() > bango){
		return (char *)vecClassData[SetPos].vecKeishyou[bango].c_str();
	}
	return "";
}

//--------------------------------------------------------------------------
// oϐo^
//--------------------------------------------------------------------------
void SvClass::SetRabel(char *pClassName, char *pTypeName, 
	char *pObjName, int StackSize, int StackErr)
{
	int SetPos = 0;

	if(Search(pClassName, &SetPos) == 0){
		std::string strClassName = pClassName;
		// \̂̏ꍇAŃZbg
		Class_Set(strClassName, 0, 1);
		////////return;
	}
	// dēo^ĂȂmF
	for(int cnt=0;cnt<(int)vecClassData[SetPos].vecRabel.size();cnt++){
		char *pObjNameX = (char *)vecClassData[SetPos].vecRabel[cnt].strObjName.c_str();
		if(MyFunc_strcmp(pObjName, pObjNameX) == 0){
			return;
		}
	}

	// o^f[^쐬
	ClassRabelInfo tmpRabel;

	tmpRabel.strObjName  = pObjName;
	tmpRabel.strTypeName = pTypeName;
	tmpRabel.stack_size  = StackSize;

	// oϐo^
	vecClassData[SetPos].vecRabel.push_back(tmpRabel);

	vecClassData[SetPos].StackSize += StackSize;
	vecClassData[SetPos].StackErr |= StackErr;
}

//--------------------------------------------------------------------------
// oϐ̌^擾
//--------------------------------------------------------------------------
char *SvClass::SearchRabelType(char *pClassName, char *pObjName, char *pCallFunc,
	std::vector<int> &vecCourse)
{
	int SetPos = 0;

	if(Search(pClassName, &SetPos) == 0){
		return "";
	}
	for(int a=0;a<(int)vecClassData[SetPos].vecRabel.size();a++){
		if(MyFunc_strcmp(pObjName, 
			(char *)vecClassData[SetPos].vecRabel[a].strObjName.c_str()) == 0){

			FuncParam FuncData;
			FuncData.strFuncName = pCallFunc;

			std::string strObjName;
			if(*pClassName != '\0'){
				strObjName  = pClassName;
				strObjName += "::";
			}
			strObjName += vecClassData[SetPos].vecRabel[a].strTypeName;
			strObjName += " ";
			strObjName += pObjName;

			// ϐ̃ANZXOۑ
			FuncObj->SetObjAccess(FuncData, strObjName);

			// ϐ̌^Ԃ
			return (char *)vecClassData[SetPos].vecRabel[a].strTypeName.c_str();
		}
	}

	if( CheckkeishyouErr(vecCourse, SetPos) ){				// [vɊׂĂ
		return "";
	}
	//------------------------------------------------------
	// NX̃oϐłȂꍇ͌p𒲂ׂ
	//------------------------------------------------------
	int tmp_max = (int)vecClassData[SetPos].vecKeishyou.size();
	for(int c=0;c<tmp_max;c++){
		char *getName = SearchRabelType((char *)vecClassData[SetPos].vecKeishyou[c].c_str(),
				pObjName, pCallFunc, vecCourse);
		if(*getName != '\0'){						// NXԂꂽ
			return getName;
		}
	}
	vecCourse.erase(vecCourse.begin()+vecCourse.size()-1);			// łȂ̂ŊKw߂

	return "";
}

//--------------------------------------------------------------------------
// NX̃TCY擾
//--------------------------------------------------------------------------
int  SvClass::GetStackSize(char *pClassName, int *StackErr)
{
	int SetPos = 0;

	*StackErr = 0;
	if(Search(pClassName, &SetPos) == 0){
		return 0;
	}
	*StackErr = vecClassData[SetPos].StackErr;

	return vecClassData[SetPos].StackSize;
}

//--------------------------------------------------------------------------
// \̖̂Oݒ肷
//--------------------------------------------------------------------------
void SvClass::ChangeOwnerClassName(char *pClassName, char *pChg)
{
	int SetPos = 0;

	if(Search(pClassName, &SetPos) == 0){
		return;
	}

	// obNAbv쐬
	ClassInfo tmpClass = vecClassData[SetPos];
	tmpClass.ClassName = pChg;

	// o^̂폜
	vecClassData.erase(vecClassData.begin()+SetPos);

	// Ȃꏊ
	if(Search(pChg, &SetPos) == 0){
		// f[^o^
		vecClassData.insert(vecClassData.begin()+SetPos, tmpClass);
	}
}


//--------------------------------------------------------------------------
// NX\
//--------------------------------------------------------------------------
void SvClass::Print(int OutFlg)
{
extern	Option   EpOp;

	if(OutFlg == 2 && FileOpenCnt){						// t@C[
		if(EpOp.FileFormat == FILE_FORMAT_HTML){
			ofstream ClassLog;					// classo͗pt@C

			EpOutFileOpenAdd("Epꗗclass.html", &ClassLog);
			ClassLog << "</body>"  << endl << "</html>"  << endl;
			ClassLog.close();
		}
		return;
	}

	if(vecClassData.size() == 0)						// NX݂Ȃ
		return;

	switch( EpOp.FileFormat ){
	case FILE_FORMAT_TEXT:
		PrintText(OutFlg);
		break;
	case FILE_FORMAT_HTML:
		PrintHtml(OutFlg);
		break;
	case FILE_FORMAT_CSV:
		PrintCsv(OutFlg);
		break;
	case FILE_FORMAT_XLS:
		PrintXls(OutFlg);
		break;
	default:
		break;
	}
}

//--------------------------------------------------------------------------
// NX\(text)
//--------------------------------------------------------------------------
void SvClass::PrintText(int OutFlg)
{
	ofstream ClassLog;							// classo͗pt@C

	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗclass.txt", &ClassLog);
	}else{
		EpOutFileOpen("Epꗗclass.txt", &ClassLog);
		FileOpenCnt++;
	}

	ClassLog << "----------------------------------------------" << endl;
	if( OutFlg ){
		ClassLog << "͑ΏۿŎgpS׽\܂B" << endl;
	}else{
		ClassLog << CoutMask(FileStackObj->GetFileName()) << "Ŏgp׽\܂B" << endl;
	}
	ClassLog << "----------------------------------------------" << endl;
	for(int a=0 ; a<(int)vecClassData.size() ; a++){
		if(vecClassData[a].ClassName.length() == 0)
			continue;
		if(vecClassData[a].UseClassCk == 0)				// gpĂȂNX͕\Ȃ
			continue;
		if(vecClassData[a].ClassType != 0){				// \̂͏
			continue;
		}
		ClassLog << "  class " << vecClassData[a].ClassName.c_str() << endl;
		for(int b=0;b<(int)vecClassData[a].vecKeishyou.size();b++){
			if(vecClassData[a].vecKeishyou[b].length() == 0)
				continue;
			ClassLog << "    {׽F" <<
				vecClassData[a].vecKeishyou[b].c_str() << endl;
		}
		//for(int b=0;b<(int)vecClassData[a].vecRabel.size();b++){
		//	ClassLog << "    ϐ: " << vecClassData[a].vecRabel[b].strTypeName.c_str() << "\t";
		//	ClassLog << vecClassData[a].vecRabel[b].strObjName.c_str() << "\t";
		//	ClassLog << vecClassData[a].vecRabel[b].stack_size << endl;
		//}
	}
	ClassLog << endl;

	ClassLog.close();							// t@C
}

//--------------------------------------------------------------------------
// NX\(html)
//--------------------------------------------------------------------------
void SvClass::PrintHtml(int OutFlg)
{
	ofstream ClassLog;							// classo͗pt@C

	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗclass.html", &ClassLog);
	}else{
		EpOutFileOpen("Epꗗclass.html", &ClassLog);
		CommonHtmlHeaderOut(&ClassLog, "NXꗗ");			// wb_[t@Co
		FileOpenCnt++;
	}

	if( OutFlg ){
		ClassLog << "<p>͑ΏۿŎgpS׽\܂B</p>" << endl;
	}else{
		ClassLog << "<p>" << CoutMask(FileStackObj->GetFileName()) << "Ŏgp׽\܂B</p>" << endl;
	}

	ClassLog << "<table border=\"1\" cellpadding=\"3\" width=\"400\">" << endl;

	CommonHtmlTableTitle(&ClassLog, "20%", "class");
	CommonHtmlTableTitle(&ClassLog, "40%", "NX");
	CommonHtmlTableTitle(&ClassLog, "40%", "{NX");
	for(int a=0 ; a<(int)vecClassData.size() ; a++){
		if(vecClassData[a].ClassName.length() == 0)
			continue;
		if(vecClassData[a].UseClassCk == 0)				// gpĂȂNX͕\Ȃ
			continue;
		if(vecClassData[a].ClassType != 0){				// \̂͏
			continue;
		}
		ClassLog << "    <tr>" << endl;
		//-----------------------------------------------------
		CommonHtmlTableStr(&ClassLog, "20%", "class");
		CommonHtmlTableStr(&ClassLog, "40%", (char *)vecClassData[a].ClassName.c_str());
		//-----------------------------------------------------
		ClassLog << "        <td valign=\"top\" width=\"40%\">";
		if(vecClassData[a].vecKeishyou.size() == 0){
			ClassLog << "@";
		}else{
			for(int b=0;b<(int)vecClassData[a].vecKeishyou.size();b++){
				ClassLog << vecClassData[a].vecKeishyou[b].c_str();

				if((b+1) != vecClassData[a].vecKeishyou.size()
				&& vecClassData[a].vecKeishyou[b+1].length() != 0){
					ClassLog << "<br>";
				}
			}
		}
		ClassLog << "</td>" << endl;
		ClassLog << "    </tr>" << endl;
	}
	ClassLog << "</table>" << endl;
	ClassLog << "<br>" << endl << "<br>" << endl << "<br>" << endl;

	ClassLog.close();							// t@C
}

//--------------------------------------------------------------------------
// NX\(csv)
//--------------------------------------------------------------------------
void SvClass::PrintCsv(int OutFlg)
{
	ofstream ClassLog;							// classo͗pt@C

	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗclass.csv", &ClassLog);
	}else{
		EpOutFileOpen("Epꗗclass.csv", &ClassLog);
		FileOpenCnt++;
	}

	ClassLog << "----------------------------------------------" << endl;
	if( OutFlg ){
		ClassLog << "͑ΏۿŎgpS׽\܂B" << endl;
	}else{
		ClassLog << CoutMask(FileStackObj->GetFileName()) << "Ŏgp׽\܂B" << endl;
	}
	ClassLog << "----------------------------------------------" << endl;

	ClassLog << "class,׽,{׽" << endl;

	for(int a=0 ; a<(int)vecClassData.size() ; a++){
		if(vecClassData[a].ClassName.length() == 0)
			continue;
		if(vecClassData[a].UseClassCk == 0)				// gpĂȂNX͕\Ȃ
			continue;
		if(vecClassData[a].ClassType != 0){				// \̂͏
			continue;
		}
		ClassLog << "class," << vecClassData[a].ClassName.c_str();
		for(int b=0;b<(int)vecClassData[a].vecKeishyou.size();b++){
			if(vecClassData[a].vecKeishyou[b].length() == 0)
				continue;
			ClassLog << vecClassData[a].vecKeishyou[b].c_str() << ",";
		}
		ClassLog << endl;
	}
	ClassLog << endl;

	ClassLog.close();							// t@C
}


//--------------------------------------------------------------------------
// NX\(xls)
//--------------------------------------------------------------------------
void SvClass::PrintXls(int OutFlg)
{
extern	void	DrawKeisen_class(int start, int end);
	char		buf[300];
	int		org_line = xls_line;
	HRESULT		hr;
	_variant_t	vSet;
	char		strEria[40];
	long		index[2];
	SAFEARRAYBOUND	sabound[2];
	SAFEARRAY	*psa;
	VARIANT		vResult;
	string		str;

	try{
		vResult.vt = VT_ARRAY|VT_VARIANT;

		//---------------t@CI[v---------------------------
		Excel_Open("NXꗗ");

		if(FileOpenCnt == 0){
			// V[gύX
			Excel_PutSheetName("NXꗗ");
			// ڂ̕ύX
			Excel_SetColomnWidth('B', 30);
			Excel_SetColomnWidth('C', 30);
			FileOpenCnt++;
		}

		sabound[0].cElements = vecClassData.size()+2;			// š
		sabound[0].lLbound   = 0;
		sabound[1].cElements = 3;					// ̌
		sabound[1].lLbound   = 0;
		// ̈mۂ
		psa = SafeArrayCreate(VT_VARIANT, 2, sabound);

		unsigned char *rgElems;
		hr = SafeArrayAccessData(psa, (void **)&rgElems);


		index[0] = 0;							// sԍ
		index[1] = 0;							// ԍ
		if( OutFlg ){
			vSet = "͑Ώۃ\[XŎgpSNX";
		}else{
			sprintf(buf, "%sŎgpNX", FileStackObj->GetFileName());
			vSet = buf;
		}
		SafeArrayPutElement(psa, index, &vSet);
		xls_line++;
		//-----------------------------------------
		index[0] = 1;							// sԍ
		index[1] = 0;							// ԍ
		vSet = "class";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 1;							// ԍ
		vSet = "NX";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 2;							// ԍ
		vSet = "{NX";
		SafeArrayPutElement(psa, index, &vSet);
		xls_line++;

		for(int a=0 ; a<(int)vecClassData.size() ; a++){
			if(vecClassData[a].ClassName.length() == 0)
				continue;
			if(vecClassData[a].UseClassCk == 0)			// gpĂȂNX͕\Ȃ
				continue;
			if(vecClassData[a].ClassType != 0){			// \̂͏
				continue;
			}

			index[0] = xls_line-org_line;				// sԍ

			index[1] = 0;						// ԍ
			vSet = "class";
			SafeArrayPutElement(psa, index, &vSet);
			index[1] = 1;						// ԍ
			vSet = vecClassData[a].ClassName.c_str();
			SafeArrayPutElement(psa, index, &vSet);

			index[1] = 2;						// ԍ
			str = "";
			for(int b=0;b<(int)vecClassData[a].vecKeishyou.size();b++){
				if(*vecClassData[a].vecKeishyou[b].c_str() == 0){
					break;
				}
				if( b ){
					str += "\n";
				}
				str += vecClassData[a].vecKeishyou[b].c_str();
			}
			vSet = str.c_str();
			SafeArrayPutElement(psa, index, &vSet);

			xls_line++;
		}
		sprintf(strEria, "A%d:C%d", org_line, xls_line-1);

		// SAFEARRAY|C^ݒ
		V_ARRAY(&vResult) = psa;
		// 쐬f[^ꊇē\t
		Excel_PasteSel(strEria, vResult);
		// SAFEARRAYJ
		SafeArrayUnaccessData(psa);

		// r
		DrawKeisen_class(org_line+1, xls_line-1);

		xls_line += 2;

	}catch(...){
	}

}


