//=============================================================================
// ^f[^ێ邽߂̃NXB
//=============================================================================
#include	<windows.h>
#include	<commctrl.h>
#include	<iostream>
#include	<fstream>
#include	<vector>
using namespace std;
#include	<comdef.h>
#include	"common.h"
#include	"SvFileStack.h"
#include	"SvType.h"


extern	SvFileStack	*FileStackObj;					// ݏ̃t@Ci[IuWFNg



//--------------------------------------------------------------------------
// `t@C݂ȂƂɎg`
// ꂽ^`B
//--------------------------------------------------------------------------
struct{
	char *TypeName;							// ^
	int  StackSize;							// ^̃TCY
} TypeInfo_OrgWord_C[] = {
	{"char",	1},
	{"int",		4},
	{"long",	4},
	{"double",	8},
	{"float",	4},
	{"short",	2},
	{"",		0}
},
TypeInfo_OrgWord_Delphi[] = {
	{"Integer",	4},	{"Cardinal",	4},	{"Shortint",	1},
	{"Smallint",	2},	{"Longint",	4},	{"Int64",	8},
	{"Byte",	1},	{"Word",	2},	{"Longword",	4},
	{"AnsiChar",	1},	{"WideChar",	2},	{"Char",	1},
	{"Boolean",	1},	{"ByteBool",	1},	{"WordBool",	2},
	{"LongBool",	4},	{"Real48",	6},	{"Single",	4},
	{"Double",	8},	{"Extended",	10},	{"Comp",	8},
	{"Currency",	8},	{"ShortString",	2},	{"AnsiString",	4},
	{"WideString",	4},	{"Variant",	16},	{"OleVariant",	16},
	{"TDateTime",	8},	{"PAnsiString",	4},	{"PString",	4},
	{"PByteArray",	4},	{"PCurrency",	4},	{"PDouble",	4},
	{"PExtended",	4},	{"PSingle",	4},	{"PInteger",	4},
	{"POleVariant",	4},	{"PShortString",4},	{"PTextBuf",	4},
	{"PVarRec",	4},	{"PVariant",	4},	{"PWideString",	4},
	{"PWordArray",	4},
	{"",		0}
},
TypeInfo_OrgWord_VB[] = {
	{"Byte",	1},
	{"Boolean",	2},
	{"Currency",	8},
	{"Date",	8},
	{"Decimal",	14},
	{"double",	8},
	{"float",	4},
	{"Integer",	2},
	{"long",	4},
	{"Object",	4},
	{"String",	10},
	{"Single",	2},
	{"Variant",	44},
	{"",		0}
};

//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
SvType::SvType()
{
	ConfigFlg = 0;
	FileOpenCnt = 0;						// o͗p̃t@CJ
	xls_line = 1;
}

//--------------------------------------------------------------------------
// fXgN^
// spɂȂGAJ
//--------------------------------------------------------------------------
SvType::~SvType()
{
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void SvType::Init(int lang)
{
	int a;

	// VBADelphi̓wb_[t@Cߌ^Ȃ
	if(lang & (MASK_BIT_VB|MASK_BIT_DELPHI)){
		int mask = ~TYPE_INFO_USED;

		for(a=0;a<(int)vecTypeData.size();a++){
			// gptONA
			vecTypeData[a].ObjInfo &= mask;
		}
		return;
	}

	vecTypeData.clear();
}

//--------------------------------------------------------------------------
// ꖈ̌^̃TCY̕ۑꏊ
//--------------------------------------------------------------------------
int SvType::GetLangPos()
{
	int  langPos = 0;
	int  lang = FileStackObj->SrcLang();

	for(langPos=0;langPos<6;langPos++){
		if((lang>>langPos) & 0x01){
			break;
		}
	}

	return langPos;
}

//--------------------------------------------------------------------------
// ^ۑB
//--------------------------------------------------------------------------
void SvType::SetData(char *pStr, int DataType, int stk_size, int stk_err)
{
	int  lang = FileStackObj->SrcLang();

	SetData(pStr, DataType, stk_size, stk_err, lang);
}

//--------------------------------------------------------------------------
// ^ۑB
// \[XƎgp͈ΈɑΉ邽߁A{Iɂ̊֐̎gp͋֎~
//--------------------------------------------------------------------------
void SvType::SetData(char *pStr, int DataType, int stk_size, int stk_err, int lang)
{
	TypeInfo tmpType;
	int  SetPos=0;


	if( Search(pStr, &SetPos, 1) ){			// o^ς݂Ȃ
		vecTypeData[SetPos].TypeBitInfo |= DataType;	// ^񂪉ۑ(ϐA\́ANX)
		vecTypeData[SetPos].LangBitInfo |= lang;	// gpۑ
		if( stk_size ){
			for(int ichi=0;ichi<6;ichi++){
				if(((lang>>ichi) & 0x01) == 0){
					continue;
				}
				if( ! vecTypeData[SetPos].TypeSize[ichi] ){
					vecTypeData[SetPos].TypeSize[ichi] = stk_size;
				}else if(vecTypeData[SetPos].TypeSize[ichi] != stk_size){
					cerr << "(װ)^̻ނ͊Ɍς݂łB^[" ;
					cerr << vecTypeData[SetPos].TypeName.c_str();
					cerr << "] ݂̻[" << vecTypeData[SetPos].TypeSize[ichi];
					cerr << "] VK[" << stk_size << "]" << endl;
				}
			}
		}
		if( stk_err ){
			vecTypeData[SetPos].ObjInfo |= TYPE_INFO_STKERR;
		}
		return;
	}

	// o^pf[^̍쐬
	tmpType.TypeName = pStr;
	tmpType.ObjInfo       = 0;
	tmpType.TypeBitInfo   = DataType;			// ^񂪉ۑ(ϐA\́ANX)
	tmpType.LangBitInfo   = lang;				// gpۑ
	memset(&tmpType.TypeSize, '\0', sizeof(tmpType.TypeSize));
	if( stk_size ){
		for(int ichi=0;ichi<6;ichi++){
			if(((lang>>ichi) & 0x01) == 0){
				continue;
			}
			tmpType.TypeSize[ichi] = stk_size;
		}
	}
	if( stk_err ){
		tmpType.ObjInfo |= TYPE_INFO_STKERR;
	}

	// f[^̓o^
	if((int)vecTypeData.size() > SetPos){
		vecTypeData.insert(vecTypeData.begin()+SetPos, tmpType);
	}else{
		vecTypeData.push_back(tmpType);
	}

}

//--------------------------------------------------------------------------
// ^̃TCY擾
//--------------------------------------------------------------------------
int  SvType::GetSize(char *ObjTypeX, int *StkErr)
{
	int  SetPos=0;
	int  langPos = GetLangPos();

	*StkErr = 0;

	if( Search(ObjTypeX, &SetPos, 1) ){		// ܂A^݂邩ǂ`FbN
		*StkErr = (vecTypeData[SetPos].ObjInfo & TYPE_INFO_STKERR ) ? 1 : 0;
		// ^̃TCYԂ
		return vecTypeData[SetPos].TypeSize[langPos];
	}
	return 0;
}

//--------------------------------------------------------------------------
// ^̎ʂ擾(ϐA\́ANX)
//--------------------------------------------------------------------------
int SvType::GetKind(char *pStr)
{
	int  SetPos=0;

	if( Search(pStr, &SetPos, 1) ){				// ܂A^݂邩ǂ`FbN
		return vecTypeData[SetPos].TypeBitInfo;		// ^̎ʂ擾(ϐA\́ANX)
	}
	return 0;
}
//--------------------------------------------------------------------------
// ^񂩂ǂ̔
// ^Ȃΐ^ԂB
//--------------------------------------------------------------------------
int SvType::Search(char *pStr)
{
	int dummy;

	return Search(pStr, &dummy, 0);
}
//--------------------------------------------------------------------------
// ^񂩂ǂ̔
// ^Ȃΐ^ԂB
//--------------------------------------------------------------------------
int SvType::Search(char *pStr, int *SetPos, int SetMode)
{
	int max = (int)vecTypeData.size()-1;			// zɕϊ
	int min = 0;
	int half= 0;
	int result;


	if(memcmp("typedef ", pStr, 8) == 0){
		pStr += 8;
	}
	std::string strMoji = pStr;

	// ev[gNX̏ꍇA"<"̑O܂ł^Ƃ
	char *new_p = strchr(pStr, '<');
	if( new_p ){
		strMoji = strMoji.substr(0, (new_p-pStr));
	}

	if( vecTypeData.size() ){
		while(1){
			half = (min+max)/2;			// ̒n_
			if(vecTypeData[half].TypeName.length() == 0 ){
				cerr << "^񌟍ɂĈُ킪܂(װ)" << endl;
				break;
			}
			result = MyFunc_strcmp((char *)strMoji.c_str(), (char *)vecTypeData[half].TypeName.c_str());
			if( result == 0 ){
				*SetPos = half;
				int Lang = FileStackObj->SrcLang();
				if(ConfigFlg == 0 && (vecTypeData[half].LangBitInfo & Lang)){
					// ^gp
					vecTypeData[half].ObjInfo |= TYPE_INFO_USED;
				}
				if(SetMode == 1){		// ^̓o^̍ۂ̌Ȃ
					return 1;		// o^ς
				}else if(SetMode == 2){		// ֐|C^ǂ̌
					if((vecTypeData[half].TypeBitInfo & OBJ_TYPE_PFUNC) == 0){
						return 0;
					}
				}
				return (vecTypeData[half].LangBitInfo & Lang);
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{					// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}
	*SetPos = half;
	return 0;
}


//--------------------------------------------------------------------------
// ݒǂݍݒǂ̃tO
//--------------------------------------------------------------------------
void SvType::ConfigFlgOnOff(int OnOff)
{
	ConfigFlg = OnOff;
}

//--------------------------------------------------------------------------
// f[^ۂƎ擾
//--------------------------------------------------------------------------
std::vector<TypeInfo> &SvType::GetVector()
{
	return vecTypeData;
}

//--------------------------------------------------------------------------
// f[^ۂƏ㏑
//--------------------------------------------------------------------------
void SvType::CopyVector(std::vector<TypeInfo> &vecUpdate)
{
	vecTypeData = vecUpdate;
}

//--------------------------------------------------------------------------
// Eptreeݒ.datt@C݂Ȃꍇ̏
//--------------------------------------------------------------------------
void SvType::FileNotExist()
{
	int a;
	for(a=0;;a++){
		if(*TypeInfo_OrgWord_C[a].TypeName == NULL)
			break;
		SetData(TypeInfo_OrgWord_C[a].TypeName, OBJ_TYPE_NON,
			TypeInfo_OrgWord_C[a].StackSize, 0, MASK_BIT_C);
	}
	for(a=0;;a++){
		if(*TypeInfo_OrgWord_VB[a].TypeName == NULL)
			break;
		SetData(TypeInfo_OrgWord_VB[a].TypeName, OBJ_TYPE_NON,
			TypeInfo_OrgWord_VB[a].StackSize, 0, MASK_BIT_VB);
	}
	for(a=0;;a++){
		if(*TypeInfo_OrgWord_Delphi[a].TypeName == NULL)
			break;
		SetData(TypeInfo_OrgWord_Delphi[a].TypeName, OBJ_TYPE_NON,
			TypeInfo_OrgWord_Delphi[a].StackSize, 0, MASK_BIT_DELPHI);
	}
}
//--------------------------------------------------------------------------
// ^\邽߂̊֐B
//--------------------------------------------------------------------------
void SvType::Print(int OutFlg)
{
extern	Option   EpOp;
	char *filename = FileStackObj->GetFileName();
	int  lang = FileStackObj->SrcLang();

	if(OutFlg == 2 && FileOpenCnt){						// t@C[
		if(EpOp.FileFormat == FILE_FORMAT_HTML){
			ofstream RabelTypeLog;					// #define`o͗pt@C

			EpOutFileOpenAdd("Epꗗtype.html", &RabelTypeLog);
			RabelTypeLog << "</body>"  << endl << "</html>"  << endl;
			RabelTypeLog.close();
		}
		return;
	}

	switch( EpOp.FileFormat ){
	case FILE_FORMAT_TEXT:
		PrintText(OutFlg, filename, lang);
		break;
	case FILE_FORMAT_HTML:
		PrintHtml(OutFlg, filename, lang);
		break;
	case FILE_FORMAT_CSV:
		PrintCsv(OutFlg, filename, lang);
		break;
	case FILE_FORMAT_XLS:
		PrintXls(OutFlg, filename, lang);
		break;
	default:
		break;
	}
}

//--------------------------------------------------------------------------
// ^\邽߂̊֐B(text)
//--------------------------------------------------------------------------
void SvType::PrintText(int OutFlg, char *filename, int lang)
{
	ofstream	RabelTypeLog;						// ^̏o͗pt@C
	int		LangPos = GetLangPos();


	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗtype.txt", &RabelTypeLog);
	}else{
		EpOutFileOpen("Epꗗtype.txt", &RabelTypeLog);
		FileOpenCnt++;
	}

	RabelTypeLog << "------------------------------------------------" << endl;
	if( OutFlg ){
		RabelTypeLog << "͑ΏۿŎgpS^o܂B" << endl;
	}else{
		RabelTypeLog << CoutMask(filename) << "Ŏgp^o܂B" << endl;
	}
	RabelTypeLog << "------------------------------------------------" << endl;

	int DispNo = 1;
	for(int a=0;a<(int)vecTypeData.size();a++){
		int  len;
		char *pp = (char *)vecTypeData[a].TypeName.c_str();
		if( pp == NULL )
			break;
		if( !(lang & vecTypeData[a].LangBitInfo) )			// gp`FbN
			continue;
		if( !(vecTypeData[a].ObjInfo & TYPE_INFO_USED) )		// ^gpĂȂ
			continue;
		RabelTypeLog.setf(ios_base::right, ios_base::adjustfield);	// Elw
		RabelTypeLog.width(4);
		RabelTypeLog << DispNo << ", ";					// No
		//-----------------------------------------------
		len = strlen(pp);
		RabelTypeLog << pp ;						// ^
		RabelTypeLog.setf(ios_base::left, ios_base::adjustfield);	// lw
		if(len < 20){
			RabelTypeLog.width(20 - len);
			len = 0;
		}else if(len < 26){
			len -= (20-1);
		}else{
			len = 6-1;
		}
		RabelTypeLog << ",";
		//-----------------------------------------------
		RabelTypeLog.setf(ios_base::right, ios_base::adjustfield);	// Elw
		RabelTypeLog.width(6-len);
		// TCY
		if(vecTypeData[a].TypeBitInfo & OBJ_TYPE_CLASS){
			RabelTypeLog << "-";
		}else{
			RabelTypeLog << vecTypeData[a].TypeSize[LangPos];
		}
		if(vecTypeData[a].ObjInfo & TYPE_INFO_STKERR){			// ^TCYvG[
			RabelTypeLog << ",(sm)";
		}
		RabelTypeLog << endl;
		DispNo++;
	}
	RabelTypeLog << endl << endl;

	RabelTypeLog.close();							// t@C
}

//--------------------------------------------------------------------------
// ^\邽߂̊֐B(html)
//--------------------------------------------------------------------------
void SvType::PrintHtml(int OutFlg, char *filename, int lang)
{
	ofstream	RabelTypeLog;						// ^̏o͗pt@C
	int		LangPos = GetLangPos();


	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗtype.html", &RabelTypeLog);
	}else{
		EpOutFileOpen("Epꗗtype.html", &RabelTypeLog);
		CommonHtmlHeaderOut(&RabelTypeLog, "^ꗗ");		// wb_[t@Co
		FileOpenCnt++;
	}

	if( OutFlg ){
		RabelTypeLog << "<p>͑ΏۿŎgpS^o܂B</p>" << endl;
	}else{
		RabelTypeLog << "<p>" << CoutMask(filename) << "Ŏgp^o܂B</p>" << endl;
	}

	RabelTypeLog << "<table border=\"1\" cellpadding=\"4\" width=\"400\">" << endl;

	int DispNo = 1;
	for(int a=0;a<(int)vecTypeData.size();a++){
		char *pp = (char *)vecTypeData[a].TypeName.c_str();
		if( pp == NULL )
			break;
		if( !(lang & vecTypeData[a].LangBitInfo) )			// gp`FbN
			continue;
		if( !(vecTypeData[a].ObjInfo & TYPE_INFO_USED) )		// ^gpĂȂ
			continue;
		RabelTypeLog << "    <tr>" << endl;
		CommonHtmlTableData(&RabelTypeLog, "10%", DispNo);		// No
		CommonHtmlTableStr(&RabelTypeLog, "50%", pp);			// ^
		// TCY
		if(vecTypeData[a].TypeBitInfo & OBJ_TYPE_CLASS){
			CommonHtmlTableStr(&RabelTypeLog, "20%", "-");
		}else{
			CommonHtmlTableData(&RabelTypeLog, "20%",
				vecTypeData[a].TypeSize[LangPos]);
		}
		char *pErrComment = NULL;
		if(vecTypeData[a].ObjInfo & TYPE_INFO_STKERR){			// ^TCYvG[
			pErrComment = "sm";					// v
		}
		CommonHtmlTableStr(&RabelTypeLog, "20%", pErrComment);		// v
		RabelTypeLog << "    </tr>" << endl;
		DispNo++;
	}
	RabelTypeLog << "</table>" << endl;
	RabelTypeLog << "<br>" << endl << "<br>" << endl << "<br>" << endl;

	RabelTypeLog.close();							// t@C
}

//--------------------------------------------------------------------------
// ^\邽߂̊֐B(CSV)
//--------------------------------------------------------------------------
void SvType::PrintCsv(int OutFlg, char *filename, int lang)
{
	ofstream	RabelTypeLog;						// ^̏o͗pt@C
	int		LangPos = GetLangPos();


	if( FileOpenCnt ){
		EpOutFileOpenAdd("Epꗗtype.csv", &RabelTypeLog);
	}else{
		EpOutFileOpen("Epꗗtype.csv", &RabelTypeLog);
		FileOpenCnt++;
	}

	RabelTypeLog << "------------------------------------------------" << endl;
	if( OutFlg ){
		RabelTypeLog << "͑ΏۿŎgpS^o܂B" << endl;
	}else{
		RabelTypeLog << CoutMask(filename) << "Ŏgp^o܂B" << endl;
	}
	RabelTypeLog << "------------------------------------------------" << endl;
	RabelTypeLog << "No,^,TCY,v" << endl;

	int DispNo = 1;
	for(int a=0;a<(int)vecTypeData.size();a++){
		char *pp = (char *)vecTypeData[a].TypeName.c_str();
		if( pp == NULL )
			break;
		if( !(lang & vecTypeData[a].LangBitInfo) )			// gp`FbN
			continue;
		if( !(vecTypeData[a].ObjInfo & TYPE_INFO_USED) )		// ^gpĂȂ
			continue;
		RabelTypeLog << DispNo << ",";					// No
		RabelTypeLog << pp << ",";					// ^
		// TCY
		if(vecTypeData[a].TypeBitInfo & OBJ_TYPE_CLASS){
			RabelTypeLog << "-,";
		}else{
			RabelTypeLog << vecTypeData[a].TypeSize[LangPos] << ",";
		}
		if(vecTypeData[a].ObjInfo & TYPE_INFO_STKERR){			// ^TCYvG[
			RabelTypeLog << "sm";
		}
		RabelTypeLog << endl;
		DispNo++;
	}
	RabelTypeLog << endl << endl;

	RabelTypeLog.close();							// t@C
}



//--------------------------------------------------------------------------
// ^\邽߂̊֐B(XLS)
//--------------------------------------------------------------------------
void SvType::PrintXls(int OutFlg, char *filename, int lang)
{
extern	void	DrawKeisen_RabelTypeList(int start, int end);
	int		org_line = xls_line;
	int		LangPos = GetLangPos();
	char		buf[300];
	HRESULT		hr;
	_variant_t	vSet;
	char		strEria[40];
	long		index[2];
	SAFEARRAYBOUND	sabound[2];
	SAFEARRAY	*psa;
	VARIANT		vResult;


	try{
		if(vecTypeData.size() == 0){
			return;
		}

		vResult.vt = VT_ARRAY|VT_VARIANT;

		//---------------t@CI[v---------------------------
		Excel_Open("^ꗗ");

		if(FileOpenCnt == 0){
			// V[gύX
			Excel_PutSheetName("^ꗗ");
			// ڂ̕ύX
			Excel_SetColomnWidth('B', 30);
			FileOpenCnt++;
		}

		sabound[0].cElements = (int)vecTypeData.size()+2;		// š
		sabound[0].lLbound   = 0;
		sabound[1].cElements = 4;					// ̌
		sabound[1].lLbound   = 0;
		// ̈mۂ
		psa = SafeArrayCreate(VT_VARIANT, 2, sabound);

		unsigned char *rgElems;
		hr = SafeArrayAccessData(psa, (void **)&rgElems);

		index[0] = 0;							// sԍ
		index[1] = 0;							// ԍ
		if( OutFlg ){
			vSet = "͑ΏۿŎgpS^";
		}else{
			sprintf(buf, "%sŎgp^", filename);
			vSet = buf;
		}
		SafeArrayPutElement(psa, index, &vSet);
		xls_line++;

		//-----------------------------------------
		index[0] = 1;							// sԍ
		index[1] = 0;							// ԍ
		vSet = "No";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 1;							// ԍ
		vSet = "^";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 2;							// ԍ
		vSet = "TCY";
		SafeArrayPutElement(psa, index, &vSet);
		index[1] = 3;							// ԍ
		vSet = "v";
		SafeArrayPutElement(psa, index, &vSet);
		xls_line++;

		int DispNo = 1;
		for(int a=0;a<(int)vecTypeData.size();a++){
			char *pp = (char *)vecTypeData[a].TypeName.c_str();
			if( pp == NULL )
				break;
			if( !(lang & vecTypeData[a].LangBitInfo) )		// gp`FbN
				continue;
			if( !(vecTypeData[a].ObjInfo & TYPE_INFO_USED) )	// ^gpĂȂ
				continue;

			index[0] = DispNo+1;					// sԍ
			// No
			index[1] = 0;						// ԍ
			vSet.intVal = DispNo;
			vSet.vt = VT_I4;
			SafeArrayPutElement(psa, index, &vSet);
			// ^
			index[1] = 1;						// ԍ
			vSet =  pp;
			vSet.vt = VT_BSTR;
			SafeArrayPutElement(psa, index, &vSet);
			// TCY
			index[1] = 2;						// ԍ
			if(vecTypeData[a].TypeBitInfo & OBJ_TYPE_CLASS){
				vSet = "-";
				vSet.vt = VT_BSTR;
			}else{
				vSet.intVal = vecTypeData[a].TypeSize[LangPos];
				vSet.vt = VT_I4;
			}
			SafeArrayPutElement(psa, index, &vSet);
			// v
			index[1] = 3;						// ԍ
			if(vecTypeData[a].ObjInfo & TYPE_INFO_STKERR){		// ^TCYvG[
				vSet = "sm";
			}else{
				vSet = "";
			}
			vSet.vt = VT_BSTR;
			SafeArrayPutElement(psa, index, &vSet);
			xls_line++;
			DispNo++;
		}

		sprintf(strEria, "A%d:D%d", org_line, org_line+DispNo+2-1);

		// SAFEARRAY|C^ݒ
		V_ARRAY(&vResult) = psa;
		// 쐬f[^ꊇē\t
		 Excel_PasteSel(strEria, vResult);
		// SAFEARRAYJ
		SafeArrayUnaccessData(psa);

		// r
		DrawKeisen_RabelTypeList(org_line+1, org_line+DispNo);

		xls_line += 2;

	}catch(...){
	}
}




